<?php
/*Jfreu's plugin 0.17a
 * http://jfreu.servegame.com
 *
 * LICENSE: This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */
 
//**events **/
Aseco::registerEvent("onStartup", "init_jfreu");
Aseco::registerEvent("onChat", "event_onchat"); 
Aseco::registerEvent("onEndRace","event_onendrace");
Aseco::registerEvent('onPlayerWins', 'event_onplayerwins');
Aseco::registerEvent("onNewChallenge","event_onnewchallenge");
Aseco::registerEvent("onBillUpdated", "event_onbillupdated");
Aseco::registerEvent("onPlayerConnect", "player_connect");
Aseco::registerEvent("onPlayerDisconnect", "player_disconnect");

Aseco::registerEvent('onPlayerFinish', 'event_onplayerfinish');


//** chat commands **//
Aseco::addChatCommand("ranklimit", "ranklimit infos");
Aseco::addChatCommand("fake", "blaguadeubal...");
Aseco::addChatCommand("infos", "your informations");
Aseco::addChatCommand("yes", "vote yes");
Aseco::addChatCommand("no", "vote no");
Aseco::addChatCommand("unspec", "launch an unspec vote");
Aseco::addChatCommand("jfreu", "Jfreu's control panel");



class Jfreu
{
	//** Jfreu's plugin version **//
	var $version;
	
	//** config **//
	var $servername;
	var $top;
	var $autochangename;
	
	//** ranklimit **//
	var $autorank;
	var $ranklimit;
	var $limit;
	var $offset;
	var $autorankminplayer;
	var $autolimit;
	var $kickhirank;
	var $maxplayers;
	var $autorankvip;
	var $hardlimit;
	
	//** colors **// aseco's colors+important message color
	var $green;
	var $white;
	var $yellow;
	var $blue;
	var $red;
	var $color;
	
	//** random info message **//
	var $messages;
	var $infomessages;
	var $message_start;
	
	//** votes **//
	var $current_vote;
	var $vote_item;
	
	//** Jfreu's Player list **//
	var $playerlist;
	
	//** BadWords **//
	var $badwords;
	var $badwordsban;
	var $badwordsnb;
	
	//** novote **//
	var $novote;
	
	//** lists : VIP, Admins, VIP_teams **//
	var $vip_list;
	var $team_vip_list;
	
	//** jfreu admin commands *//
	var $jfreu_admin_commands;
	
	//** Warning message **//
	var $warning;
	
	//** Bets + coppers**//
	var $betsystem;
	var $ticketvalue;
	var $bet_list;
	var $bettime;
	var $betjackpot;
	var $winjackpot;
	var $betpercent;
	var $jfreupercent;
	var $winpercent;
	var $paywinner;
	var $jackpotminplayer;
	
	//** others **//
	var $timerace;
	
	//** tmx world rec **//
	var $tmxwr;
	var $tmxlink;
	
	//** funnynick **//
	var $funnynick;
	
	//** autotimelimit **//
 	var $atl_multiplicator;
	var $atl_min;
	var $atl_max;
	var $atl_default;
	var $atl_status;
	
	//** ownerLogin **\\
	var $ownerLogin;
	
	//** force vote **\\
	var $forcedvote;
	
	//** lastmap **\\
	var $lastmapID;
	var $lastmapName;
	
	//** weekchallenge **//
	var $challenge;
	var $challenge_list;
	var $server_key;
	var $failed_requests;
	var $challenge_ban_list;
	var $challenge_this_track; // yes = 1 | no=0
	var $bill_list;
	var $challenge_update_time; // X min between 2 updates
	var $challenge_last_update;
	
	//** turn on**//
	var $weekchallenge_on;
	var $betsystem_on;
	var $paywinner_on;
	
	//** net_server **\\
	var $net_server;
}
class jfreu_challenge
{
    var $name; // challengename
	var $challengers;
	var $price;
	var $trackuid;
	var $id; // challenge ID
	var $endTime;
	var $trackname;
	var $environment;
	var $update;
	var $jackpot; // challengeCoppers
	var $wcInfo;
	var $trackauthor;
	var $status;
	function jfreu_challenge($id)
	{
		$this->id=$id;
		$this->status=0; // status 0 = inactive
	}
}
class joueur // element joueur
{
	var $hasvoted;
	var $speconly; // speconly status
	var $isvip;
	var $badwords;
	var $kicked;
	var $unspec;
	var $banned; // 1=banned || >1=timestamp unban
	
	var $nation;
	
	// ADMIN CONTROL PANEL //
	var $panel;
	var $other_panel; //0=no || 1=forced vote | 2=Challenge
	var $nickname;
	
	// challenge //
	var $bill_challenge;
}
class vote
{
	var $yes;
	var $no;
	var $total;
	var $nb_votes_needed;
	var $type;
	
	//** truc **//
	var $login;
}
class jfreu_command
{
	var $name;
	var $help;
}
class ticket
{
	var $login_buyer;
	var $login_bet;
	var $paid;
	var $billid;
	var $nb;
}
include('chat.jfreu.php');
include('chat.jfreu2.php');
include('jfreu/jfreu.funcs.inc.php');
function init_jfreu(&$aseco,$command)
{
	include("jfreu.config.php");
	$version="0.17a";
	$aseco->server->jfreu = new Jfreu();
	$aseco->server->jfreu->version=$version;
	$aseco->server->jfreu->servername=$servername;
	$aseco->server->jfreu->autorank=$autorank;
	$aseco->server->jfreu->ranklimit=$ranklimit;
	$aseco->server->jfreu->limit=$limit;
	$aseco->server->jfreu->offset=$offset;
	$aseco->server->jfreu->vip_list=$vip_list;
	$aseco->server->jfreu->autorankminplayer=$autorankminplayer;
	$aseco->server->jfreu->autolimit=$limit;
	$aseco->server->jfreu->maxplayers=$maxplayers;
	$aseco->server->jfreu->kickhirank=$kickhirank;
	$aseco->server->jfreu->autorankvip=$autorankvip;
	$aseco->server->jfreu->kicked=0;
	$aseco->server->jfreu->hardlimit=$hardlimit;
	$aseco->server->jfreu->top=$top;
	$aseco->server->jfreu->message_start=$message_start;
	$aseco->server->jfreu->autochangename=$autochangename;
	
	//** net_server **\\
	$aseco->server->jfreu->net_server="tm.die-webber.com";
	
	//** bets **//
	$aseco->server->jfreu->betsystem=0;
	$aseco->server->jfreu->betsystem_on=$betsystem;
	$aseco->server->jfreu->ticketvalue=$ticketvalue;
	$aseco->server->jfreu->bet_list=array();
	$aseco->server->jfreu->bettime=$bettime;
	$aseco->server->jfreu->betpercent=$betpercent;
	$aseco->server->jfreu->winpercent=$winpercent;
	$aseco->server->jfreu->paywinner=0;
	$aseco->server->jfreu->paywinner_on=$paywinner;
	$aseco->server->jfreu->jackpotminplayer=$jackpotminplayer;
	bet_reset_bets($aseco);
	reset_pay_winner($aseco);
	
	//** colors **//
	$gre=$aseco->server->jfreu->green=$aseco->formatColors('$z$s{#record}');
	$whi=$aseco->server->jfreu->white=$aseco->formatColors('$z$s{#highlite}');
	$yel=$aseco->server->jfreu->yellow=$aseco->formatColors('$z$s{#server}');
	$blu=$aseco->server->jfreu->blue=$aseco->formatColors('$z$s{#message}');
	$red=$aseco->server->jfreu->red=$aseco->formatColors('$z$s{#error}');
	$col=$aseco->server->jfreu->color=$color;
	
	//** badwords **//
	$aseco->server->jfreu->badwords=$badwords;
	$aseco->server->jfreu->badwordsban=$badwordsban;
	$aseco->server->jfreu->badwordsnb=$badwordsnb;
	
	//** novote **//
	$aseco->server->jfreu->novote=$novote;
	
	//** tmx world rec **//
	$aseco->server->jfreu->tmxwr=$tmxwr;
	$aseco->server->jfreu->tmxlink=$tmxlink;
	
	//** funnynick **//
	$aseco->server->jfreu->funnynick=$funnynick;
	
	//** autotimelimit **//
	$aseco->server->jfreu->atl_multiplicator=$atl_multiplicator;
	$aseco->server->jfreu->atl_min=$atl_min;
	$aseco->server->jfreu->atl_max=$atl_max;
	$aseco->server->jfreu->atl_default=$atl_default;
	$aseco->server->jfreu->atl_status=$atl_status;
	
	//** weekchallenge **\\
	$aseco->server->jfreu->challenge=0;//$weekchallenge;
	$aseco->server->jfreu->weekchallenge_on=$weekchallenge;
	$aseco->server->jfreu->bank=0;
	$aseco->server->jfreu->challenge_this_track=0;
	$aseco->server->jfreu->challenge_update_time=$challenge_update_time; // X min between 2 updates
	$aseco->server->jfreu->challenge_last_update=time();
	
	//** ownerLogin **\\
	$aseco->server->jfreu->ownerLogin=$ownerLogin;
	
	//** forcedVote **\\
	$aseco->server->jfreu->forcedvote=$forcedvote;
	
	//** random information messages **//
	$aseco->server->jfreu->infomessages=$infomessages;
	$aseco->server->jfreu->messages=$messages;
	
	//** playerlist **//
	if(isset($aseco->server->players->player_list))
	{
		foreach($aseco->server->players->player_list as $pl)
		{
			ajouter_joueur_liste($aseco,$pl,0,0);
		}
	}
	
	//** Votes **//
	$aseco->server->jfreu->vote_item=new vote();
	$aseco->server->jfreu->vote_item->login='';
	$aseco->server->jfreu->vote_item->yes=0;
	$aseco->server->jfreu->vote_item->no=0;
	$aseco->server->jfreu->vote_item->total=0;
	$aseco->server->jfreu->vote_item->type='';
	$aseco->server->jfreu->vote_item->nb_votes_needed=0;
	$aseco->server->jfreu->current_vote=0;
	
	//** init jfreu admin commands **//
	$aseco->server->jfreu->jfreu_admin_command=array();
	init_jfreu_admin_commands($aseco);
	
	//** Permanent VIP & Admins **//
	$aseco->server->jfreu->team_vip_list=array();
	$aseco->server->jfreu->vip_list=array();
	read_lists_xml($aseco); // read xml file (Admins/Vip/TeamVip)
	clean_guest_list($aseco);
	write_guest_list($aseco); // vip -> guests
	
	//** Warning message **//	
	$aseco->server->jfreu->warning=$warning;
	
	// register server & launch challenge
	if($aseco->server->jfreu->weekchallenge_on==1)
	{
		jfreu_load_challenges($aseco);
	}
	
	//** Loaded message **//
	$message=$aseco->server->jfreu->yellow.'>> '.$whi.'Jfreu'.$blu.'\'s plugin '.$gre.$version.$blu.' : '.$whi.'Loaded'.$blu.'.';
	$aseco->addCall("ChatSendServerMessage", array($message));
	set_ranklimit($aseco,$limit,$autorank);
	
	//** up to date test **//
	$aseco->addCall("ChatSendServerMessage", array(up_to_date($aseco)));
	
}
function set_time(&$aseco,$args)
{
	$aseco->server->jfreu->timerace=time();
}
function chat_unspec(&$aseco,$command)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	if($aseco->server->jfreu->playerlist[$command['author']->login]->speconly==1)
	{
		if($aseco->server->jfreu->current_vote==0)
		{
			new_vote($aseco,'unspec',$command['author']->login);
		}
		else
		{
			$message=$yel.'>> '.$blu.'Wait the end of the current vote.';
			$aseco->addCall("ChatSendServerMessageToLogin", array($message, $command['author']->login));
		}
	}
	else
	{
		$message=$yel.'>> '.$blu.'This command is only for SpecOnly players.';
		$aseco->addCall("ChatSendServerMessageToLogin", array($message, $command['author']->login));
	}
}
function chat_yes(&$aseco, $command)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$login=$command['author']->login;
	
	if($aseco->server->jfreu->current_vote==0)
	{
		$message=$yel.'>> '.$blu.'No current vote.';
		$aseco->addCall("ChatSendServerMessageToLogin", array($message, $login));
		return 0;
	}
	if($aseco->server->jfreu->playerlist[$login]->speconly==1)
	{
		$message=$yel.'>> '.$blu.'SpecOnly can\'t vote.';
		$aseco->addCall("ChatSendServerMessageToLogin", array($message, $login));
		return 0;
	}
	if($aseco->server->jfreu->playerlist[$login]->hasvoted==0)
	{
		vote_yes_no($aseco,1,0);
		$aseco->server->jfreu->playerlist[$login]->hasvoted=1;
		$message=$yel.'>> '.$blu.'You have voted '.$whi.' yes'.$blu.'.';
		$aseco->addCall("ChatSendServerMessageToLogin", array($message, $login));
	}
	elseif($aseco->server->jfreu->playerlist[$login]->hasvoted==1)
	{
		$message=$yel.'>> '.$blu.'You have already voted '.$whi.' yes'.$blu.'.';
		$aseco->addCall("ChatSendServerMessageToLogin", array($message, $login));
	}
	elseif($aseco->server->jfreu->playerlist[$login]->hasvoted==-1)
	{
		vote_yes_no($aseco,1,1);
		$aseco->server->jfreu->playerlist[$login]->hasvoted=1;
		$message=$yel.'>> '.$blu.'You change your vote to '.$whi.'yes'.$blu.'.';
		$aseco->addCall("ChatSendServerMessageToLogin", array($message, $login));
	}
}
function chat_no(&$aseco, $command)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$login=$command['author']->login;
	
	if($aseco->server->jfreu->current_vote==0)
	{
		$message=$yel.'>> '.$blu.'No current vote.';
		$aseco->addCall("ChatSendServerMessageToLogin", array($message, $login));
		return 0;
	}
	if($aseco->server->jfreu->playerlist[$login]->speconly==1)
	{
		$message=$yel.'>> '.$blu.'SpecOnly can\'t vote.';
		$aseco->addCall("ChatSendServerMessageToLogin", array($message, $login));
		return 0;
	}
	if($aseco->server->jfreu->playerlist[$login]->hasvoted==0)
	{
		vote_yes_no($aseco,0,0);
		$aseco->server->jfreu->playerlist[$login]->hasvoted=-1;
		$message=$yel.'>> '.$blu.'You have voted '.$whi.' no'.$blu.'.';
		$aseco->addCall("ChatSendServerMessageToLogin", array($message, $login));
	}
	elseif($aseco->server->jfreu->playerlist[$login]->hasvoted==-1)
	{
		$message=$yel.'>> '.$blu.'You have already voted '.$whi.' no'.$blu.'.';
		$aseco->addCall("ChatSendServerMessageToLogin", array($message, $command->login));
	}
	elseif($aseco->server->jfreu->playerlist[$login]->hasvoted==1)
	{
		vote_yes_no($aseco,0,1);
		$aseco->server->jfreu->playerlist[$login]->hasvoted=-1;
		$message=$yel.'>> '.$blu.'You change your vote to '.$whi.'no'.$blu.'.';
		$aseco->addCall("ChatSendServerMessageToLogin", array($message, $login));
	}
}
function chat_ranklimit(&$aseco, $command)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$login=$command['author']->login;
	if($aseco->server->jfreu->ranklimit==1)
	{
		if($aseco->server->jfreu->autorank==0)
		{
			$message=$yel.'>> '.$blu.'RankLimit : '.$whi.$aseco->server->jfreu->limit;
		}
		elseif($aseco->server->jfreu->autorank==1)
		{
			$message=$yel.'>> '.$blu.'Auto-RankLimit : '.$whi.$aseco->server->jfreu->autolimit;
		}
	}
	else
	{
		$message=$yel.'>> '.$blu.'RankLimit : '.$whi.'OFF'.$blu.'.';
	}
    $aseco->addCall("ChatSendServerMessageToLogin", array($message,$login));
}
function chat_fake(&$aseco,$command)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$rank=1;
	$time1=rand(20,30);
	$time2=rand(10,99);
	$nick=$command['author']->nickname;
	if($clean_nick=clean_nick($nick))
	{
		$message=$yel.'>> '.$whi.clean_nick($nick).$gre.' took the '.$whi.$rank.'.'.$gre.' Local Record with a time of '.$whi.'00:'.$time1.'.'.$time2.$gre.'! $000(fake)';
		$aseco->addCall("ChatSendServerMessage", array($message));
	}
}
function chat_infos(&$aseco,$command)
{
	$ip=$command['author']->ip;
	$nick=$command['author']->nickname;
	$login=$command['author']->login;
	$ladderrank=$command['author']->ladderrank;
	$ladderscore=$command['author']->ladderscore;
	$id=$command['author']->id;
	$nation=$command['author']->nation;
	$message='$FF0-$FFFIP $FF0: $FFF'.$ip;
   	$aseco->addCall("ChatSendServerMessageToLogin", array($message, $login));
	$message='$FF0-$FFFLogin$FF0/$FFFNick $FF0: $fff'.$login.'$FF0/$FFF'.clean_nick($nick);
	$aseco->addCall("ChatSendServerMessageToLogin", array($message, $login));
	$message='$FF0-$FFFScore$FFO/$FFFRank$FFO/$FFFNation $FF0: $FFF'.$ladderscore.'$FF0/$FFF'.$ladderrank.'$FF0/$FFF'.$nation;
	$aseco->addCall("ChatSendServerMessageToLogin", array($message, $login));
}
function chat_uptodate(&$aseco,$command)
{
	$aseco->addCall("ChatSendServerMessage", array(up_to_date($aseco)));
}
function bet_end(&$aseco,&$player)
{
	if($aseco->server->jfreu->betsystem==0)
	{
		return 0;
	}
	$winner_login=$player->login;
	bet_pay_winners($aseco,$winner_login);
	bet_reset_bets($aseco);
}

function tmxwr(&$aseco,$challenge) // + authortime
{
	if($aseco->server->jfreu->tmxwr==0)
	{
		return 0;
	}
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color;
	$uid=$challenge->uid;
	if(($contents=read_net_file("http://".$aseco->server->jfreu->net_server."/plugin/tmxwr.php?uid=".$uid)) && !get_error($contents))
	{
		if($contents!=" " && $contents!="" && strlen($contents)<10)
		{
			$message=$yel.">> ".$blu."TMX world record : ".$whi.$contents.$blu."| Author time : ".$whi.formatTime($challenge->authortime).$blu.".";
			$aseco->addCall("ChatSendServerMessage", array($message));
		}
		else
		{
			
		}
	}
}
function tmxlink(&$aseco,$command)
{
	if($aseco->server->jfreu->tmxlink==0)
	{
		return 0;
	}
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color;
	$uid=$aseco->server->challenge->uid;
	$name=$aseco->server->challenge->name;
	$message=$yel.">> ".$blu."Click to award this track : ".$col.'$i$l[http://united.tm-exchange.com/main.aspx?action=trackshow&uid='.$uid."]".clean_nick($name).'$l.';
	$aseco->addCall("ChatSendServerMessage", array($message));
}
function chat_n(&$aseco,$command)
{
	if($aseco->server->jfreu->funnynick==0)
	{
		return 0;
	}
	if(isset($aseco->server->jfreu->playerlist[$command['author']->login]->nickname))
	{
		$nick=$aseco->server->jfreu->playerlist[$command['author']->login]->nickname;
	}
	else
	{
		$nick=$command['author']->nickname;
	}
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color;
	$message='$z$s['.$nick.'$z$s] ';
	$message.=$command['params'];
	$aseco->addCall("ChatSendServerMessage", array($message));
}
function chat_nick(&$aseco,$command)
{
	if($aseco->server->jfreu->funnynick==0)
	{
		return 0;
	}
	if($command['params']!="")
	{
		$red=$aseco->server->jfreu->red;
		$yel=$aseco->server->jfreu->yellow;
		$whi=$aseco->server->jfreu->white;
		$blu=$aseco->server->jfreu->blue;
		$gre=$aseco->server->jfreu->green;
		$col=$aseco->server->jfreu->color;
		$aseco->server->jfreu->playerlist[$command['author']->login]->nickname=$command['params'];
		$message=$yel.">> ".$blu.'Your new nickname : [$z$s'.$command['params'].'$z$s'.$blu.'] use '.$whi.'/n message'.$blu.' to use it.';
		$aseco->addCall("ChatSendServerMessageToLogin", array($message, $command['author']->login));
	}
	else
	{
		
	}
}
//Func pimped by ck|cyrus
//05-01-2007
 function autotimelimit($aseco,$challenge)
{
	//ATL activated
	if($aseco->server->jfreu->atl_multiplicator>0 && $aseco->server->jfreu->atl_status == 1)
	{
		$aseco->client->query('GetGameInfos');
		$GameInfos = $aseco->client->getResponse();
	
		if($GameInfos['NextGameInfos']['GameMode']==1) //Next Map is in TA
		{
			//Prevent behaviour of TMU server if no player is on server
			//FIX FOR Server version 2.0.9 "TmUnited."
			if(count($aseco->server->players->player_list) == 0 && substr($aseco->server->game,0, 8)  == 'TmUnited')
				$challenge=get_trackinfo($aseco,0);
			else
				$challenge=get_trackinfo($aseco,1);
				
			$newtime=$challenge->authortime;			
			$newtime*=$aseco->server->jfreu->atl_multiplicator;
			if($newtime<=0 || empty($newtime) || !is_integer($newtime))
			{
				$newtime=($aseco->server->jfreu->atl_default*1000);
				$aseco->console_text("Setting Default Time...");
			}
			//mintime , maxtime check
			if($newtime < ($aseco->server->jfreu->atl_min*1000)) $newtime = $aseco->server->jfreu->atl_min*1000;
			if($newtime > ($aseco->server->jfreu->atl_max*1000)) $newtime = $aseco->server->jfreu->atl_max*1000;
			
			settype($newtime,'integer');
			$aseco->client->addcall('SetTimeAttackLimit',array($newtime));
			$aseco->console_text("Set timelimit for \"".stripColors($challenge->name)."\":  ".$newtime." (Authortime: ".$challenge->authortime.")");
		}
	}
} 
//Func pimped by ck|cyrus
//05-01-2007
function get_trackinfo($aseco, $offsetToCurrentTrack = 1) //offset default 1 (next track) e.g. -1 would be last track
{
	//Get Tracklist
	$tracks = $aseco->client->addCall("GetChallengeList", array(500, 0));
	if (!$aseco->client->multiquery())
	{
		trigger_error('[' . $aseco->client->getErrorCode() . '] ' . $aseco->client->getErrorMessage());
		$trackresponse = array();
		return false;
	}
	
	$trackresponse = $aseco->client->getResponse();
	
	//Number of Challenges
	$challengeCount = count($trackresponse[$tracks][0]);
	//Get Current Trackposition
	$trackid = $aseco->client->addCall("GetCurrentChallengeIndex", array());
	if (!$aseco->client->multiquery())
	{
		trigger_error('[' . $aseco->client->getErrorCode() . '] ' . $aseco->client->getErrorMessage());
		$trackidresponse = array();
		return false;
	}
	$trackidresponse = $aseco->client->getResponse();
	
	//Current Challenge Index
	$challengeIndex = $trackidresponse[$trackid][0];
	//Handle swap...
	if($challengeIndex+$offsetToCurrentTrack >= $challengeCount)
	{
		//End of Tracklist
		$getChallengeIndex = $challengeIndex+$offsetToCurrentTrack-$challengeCount;
	}
	elseif($challengeIndex+$offsetToCurrentTrack < 0)
	{
		$getChallengeIndex = $challengeCount+$challengeIndex+$offsetToCurrentTrack;
	}
	else
	{
		$getChallengeIndex = $challengeIndex+$offsetToCurrentTrack;
	}
	//Get Challenge Infos
	$gettrackinfo = $aseco->client->addCall("GetChallengeInfo", array($trackresponse[$tracks][0][$getChallengeIndex]['FileName']));
	if (!$aseco->client->multiquery())
	{
		trigger_error('[' . $aseco->client->getErrorCode() . '] ' . $aseco->client->getErrorMessage());
		$gettrackinfo = array();
		return false;
	}
	$gettrackinforesponse = $aseco->client->getResponse();
	return new Challenge($gettrackinforesponse[$gettrackinfo][0]);
}
function chat_coppers($aseco,$command)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color;
	$login=$command['author']->login;
	$message=$yel.">> ".$blu."Server coppers : ".$whi.get_coppers($aseco).$blu." copper(s).";
	$aseco->addCall("ChatSendServerMessageToLogin", array($message, $command['author']->login));
}
function pay_winner(&$aseco,&$player)
{
	if($aseco->server->jfreu->paywinner!=1)
	{
		return 0;
	}
	if($aseco->server->jfreu->winjackpot>0)
	{
		$red=$aseco->server->jfreu->red;
		$yel=$aseco->server->jfreu->yellow;
		$whi=$aseco->server->jfreu->white;
		$blu=$aseco->server->jfreu->blue;
		$gre=$aseco->server->jfreu->green;
		$col=$aseco->server->jfreu->color;
		$winner_login=$player->login;
		$player_winner=$aseco->server->players->getPlayer($winner_login);
		$nick=$player_winner->nickname;
		bet_pay_racewinner($aseco,$winner_login,$aseco->server->jfreu->winjackpot);
		$message1=$yel.">> ".$blu."RaceWinner : ".$whi.clean_nick($nick).$blu." wins ".$whi.$aseco->server->jfreu->winjackpot.$blu." copper(s).";
		$message2=$yel.">> ".$blu."You win ".$whi.$aseco->server->jfreu->winjackpot.$blu." coppers.";
		$aseco->addCall("ChatSendServerMessage", array($message1));
		$aseco->addCall("ChatSendServerMessageToLogin", array($message2, $winner_login));
	}
	reset_pay_winner($aseco);
}
function event_onchat(&$aseco,$command)
{
	novote($aseco,$command);
	BadWords($aseco,$command);
	kick_player_spec($aseco,$command);
}
function event_onendrace(&$aseco,$command)
{
	hide_minipanel($aseco);
	save_challenge_info($aseco,$command);
	forced_vote($aseco,$command);
	autotimelimit($aseco,$command);
	kick_hirank($aseco,$command);
	info_message($aseco,$command);
	vote_end($aseco,$command);
	tmxlink($aseco,$command);
	update_challenges($aseco);
	challenge_pay_winners($aseco);
	do_failed_net_requests($aseco,$command);
	turn_on($aseco,$command);
}
function event_onplayerwins(&$aseco,$command)
{
	bet_end($aseco,$command);
	pay_winner($aseco,$command);
}
function event_onnewchallenge(&$aseco,$command)
{
	set_time($aseco,$command);
	tmxwr($aseco,$command);
	challenge_this_challenge($aseco,$command);
}
function event_onbillupdated(&$aseco,$command)
{
	if(bet_bill_update($aseco,$command)==1){return 1;}
	if(challenge_register_challenger($aseco,$command)==1){return 1;}
	return 0;
}
function chat_reset(&$aseco,$command)
{
	$login=$command['author']->login;
	if($aseco->isAdmin($login))
	{
		reset_pay_winner($aseco);
		bet_reset_bets($aseco);
	}
}
function chat_challenge(&$aseco,$command)
{
	$login=$command['author']->login;
	if($aseco->isAdmin($login))
	{
		$aseco->server->jfreu->weekchallenge_on=1;
		$aseco->server->jfreu->weekchallenge=0;
		jfreu_load_challenges($aseco);
	}
}
function event_onplayerfinish(&$aseco, $finish_item)
{
	challenge_playerfinish($aseco, $finish_item);
}
?>