<?php
function get_nation(&$aseco,$login)
{
	if (!$aseco->client->query('GetDetailedPlayerInfo',$login))
	{
		$aseco->console("[Problem] client query failed (".$aseco->server->ip.":".$aseco->server->port.")");
	}
	$PlayerDetailedInfo = $aseco->client->getResponse();
	$path=$PlayerDetailedInfo['Path'];
	$paths=explode("|",$path);
	$nation=$paths[1];
	return $nation;
}
function clean_nick($nick)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$propre=stripColors($nick);
	if($propre=="")
	{
		return false;
	}
	if(strlen($propre)>15)
	{
		$propre='$n'.$propre;
	}
	return $propre;
}
function kicker_login(&$aseco,$login)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$message =$yel.'>> '.$red.'You\'ve been kicked. Bye!';
	$aseco->addCall("ChatSendServerMessageToLogin", array($message, $login));
	$aseco->addCall("Kick", array($login));
}
function kick_hirank(&$aseco)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	if($aseco->server->jfreu->kickhirank==1)
	{
		$nbjoueurs=count($aseco->server->players->player_list);
		$max=$aseco->server->jfreu->maxplayers;
		$trop=$nbjoueurs-$max;
		if($trop>0)
		{
			$message=$yel.'>> '.$blu.'Server is full ('.$red.$nbjoueurs.$blu.'/'.$whi.$max.$blu.') : $n'.$whi.$trop.$blu.' Hi-rank player(s) will be kicked.';
			$aseco->addCall("ChatSendServerMessage", array($message));
			kickworst($aseco,$trop);
		}			
		else
		{
			$message=$yel.'>> '.$blu.'Server is not full ('.$gre.$nbjoueurs.$blu.'/'.$whi.$max.$blu.') : '.$gre.'No kick'.$blu.'.';
			$aseco->addCall("ChatSendServerMessage", array($message));
		}
	}
}
function chat_message(&$aseco,$command)
{
	if($aseco->server->jfreu->infomessages==0)
	{
		$message=$yel.'>> '.$blu.'messages '.$whi.'OFF'.$blu.'.';
		$aseco->addCall("ChatSendServerMessage", array($message));	
		return 0;
	}
	info_message(&$aseco,$command);
}
//Func pimped by ck|cyrus
//03-01-2007
function info_message($aseco,$command)
{
	//Abort if Infos disabled
	if($aseco->server->jfreu->infomessages==0) return 0;

	$message=$aseco->server->jfreu->message_start;
	
	//Randomize messages
	$i=rand(1,count($aseco->server->jfreu->messages))-1;
	
	$message.=$aseco->server->jfreu->messages[$i];
	
	foreach(StringExplode($message) AS $temp)	$aseco->addCall("ChatSendServerMessage", array($temp));	
}
function set_ranklimit(&$aseco,$limit,$auto)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	if(isset($limit) && $limit!=0)
	{
		$message="";
		if($auto==1) // autorank ON --> limit changed by autorank fonction
		{
			$aseco->server->jfreu->autolimit=round($limit,0);
			$message=$yel.'>> '.$blu.'AutoRank Limit : '.$whi.round($limit,0);
		}
		elseif($auto==0) // autorank OFF --> limit changed by admin
		{
			$aseco->server->jfreu->limit=round($limit,0);
			$message=$yel.'>> '.$blu.'New Rank Limit : '.$whi.round($limit,0);
		}
		elseif($auto==2) // autorank ON --> limit forced by admin
		{
			$aseco->server->jfreu->autolimit=round($limit,0);
			$message=$yel.'>> '.$blu.'AutoRank Limit : '.$whi.round($limit,0).$blu.' (forced by admin)';
		}
		$aseco->addCall("ChatSendServerMessage", array($message));
		if($aseco->server->jfreu->autochangename==1)
		{
			$servername=$aseco->server->jfreu->servername.$aseco->server->jfreu->top.round($limit,0);
			$aseco->addCall("SetServerName", array($servername));
		}
	}
}
function autorank(&$aseco,$command)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$nbjoueurs=count($aseco->server->players->player_list);
	$nbjoueurs2=0;
	$somme=0;
	$limit=$aseco->server->jfreu->autolimit;
	if($nbjoueurs!=0 && $aseco->server->jfreu->autorankminplayer<=$nbjoueurs)
	{
		foreach($aseco->server->players->player_list as $pl)
		{
			if(isset($pl->ladderrank) && $pl->ladderrank!=0 && $aseco->server->jfreu->playerlist[$pl->login]->speconly!=1)
			{
				if($aseco->server->jfreu->autorankvip==1 && (isvip($aseco,$pl->login)==1 || isunspec($aseco,$pl->login)==1) && $pl->ladderrank>$limit)
				{
					// vip over ranklimit & autorankvip ON : nothing to do
				}
				else
				{
					$somme+=($pl->ladderrank);
					$nbjoueurs2++;
				}
			}
		}
		if($somme!=0)
		{
		    $moyenne=$somme/$nbjoueurs2;
			$offset=$aseco->server->jfreu->offset;
	        set_ranklimit($aseco,$moyenne+$offset,1);
	    }
	}
	else
	{
		$message=$yel.'>> '.$blu.'Not enough players('.$whi.$nbjoueurs.$blu.'/'.$whi.$aseco->server->jfreu->autorankminplayer.$blu.') (autorank '.$red.'disabled'.$blu.').';
		$aseco->addCall("ChatSendServerMessage", array($message));
		set_ranklimit($aseco,$aseco->server->jfreu->limit,1);
	}
}
function autokick(&$aseco,$command) // retourne 0 si kick et 1 si pas kick
{
	$limit=$aseco->server->jfreu->limit;
	if($aseco->server->jfreu->autorank==1)
	{
		$limit=$aseco->server->jfreu->autolimit;
	}
	if($aseco->server->jfreu->hardlimit!=0 && $command->ladderrank>$aseco->server->jfreu->hardlimit || $command->ladderrank==0)
	{
		ajouter_joueur_liste($aseco,$command,0,0);
		$aseco->server->jfreu->playerlist[$command->login]->kicked=1;
		$aseco->addCall("Kick", array($command->login));
		return 0;
	}
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$login=$command->login;
	if ($command->ladderrank > $limit || $command->ladderrank==0)
	{
		// hirank
		if(isvip($aseco,$command->login)==0 && $command->isspectator==0 && !in_array($command->teamname, $aseco->server->jfreu->team_vip_list))
		{
			// n'est pas dans la liste VIP
			// kick du joueur
			$message =$yel.'>> '.$red.'This server is only for players with a rank lower than '.$limit.'!';
			$aseco->addCall("ChatSendServerMessageToLogin", array($message, $command->login));
			$aseco->console("[AutoRankKick] >> player \"{1}\" kicked (rank : {2})", $command->login, $command->ladderrank);
			$aseco->addCall("Kick", array($command->login));
			if($clean_nick=clean_nick($command->nickname))
			{
				$message=$yel.'>> '.$blu.'New Player : '.$whi.$clean_nick.$blu.' Rank : '.$red.$command->ladderrank.$blu.' ['.$red.'Kicked'.$blu.'] Nation : '.$whi.get_nation($aseco,$login).$blu.'.';
				$aseco->addCall("ChatSendServerMessage", array($message));
			}
			ajouter_joueur_liste($aseco,$command,0,0);
			$aseco->server->jfreu->playerlist[$command->login]->kicked=1;
			return 0;
		}
		elseif($command->isspectator==1 && !in_array($command->login, $aseco->server->jfreu->vip_list)) // hirank spec
		{
			if($clean_nick=clean_nick($command->nickname))
			{
				ajouter_joueur_liste($aseco,$command,0,1);
				$message=$yel.'>> '.$blu.'New Player : '.$whi.$clean_nick.$blu.' Rank : '.$red.$command->ladderrank.$blu.' ['.$gre.'SpecOnly'.$blu.'] Nation : '.$whi.get_nation($aseco,$login).$blu.'.';
				$aseco->addCall("ChatSendServerMessage", array($message));
				spec_message($aseco,$command->login);
			}
			return 0;
		}
		else
		{
			// est dans la liste des VIP
			ajouter_joueur_liste($aseco,$command,1,0);
			if($clean_nick=clean_nick($command->nickname))
			{
				$message=$yel.'>> '.$blu.'New Player : '.$whi.$clean_nick.$blu.' Rank : '.$red.$command->ladderrank.$blu.' ['.$gre.'VIP'.$blu.'] Nation : '.$whi.get_nation($aseco,$login).$blu.'.';
			    $aseco->addCall("ChatSendServerMessage", array($message));
			}
        }
	}
	else
	{
		// nouveau joueur
		ajouter_joueur_liste($aseco,$command,0,0);
		if($clean_nick=clean_nick($command->nickname))
		{
			$message=$yel.'>> '.$blu.'New Player : '.$whi.$clean_nick.$blu.' Rank : '.$whi.$command->ladderrank.$blu.' ['.$gre.'OK'.$blu.'] Nation : '.$whi.get_nation($aseco,$login).$blu.'.';
			$aseco->addCall("ChatSendServerMessage", array($message));
		}
	}
	return 1;
}
function cancel_vote(&$aseco,$login)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	if($aseco->server->jfreu->current_vote==1)
	{
		if($aseco->server->jfreu->vote_item->login==$login)
		{
			vote_end($aseco);
			if($clean_nick=clean_nick($login))
			{
				$message=$yel.'>> '.$whi.$clean_nick.$blu.'\'s vote cancelled.';
				$aseco->addCall("ChatSendServerMessage", array($message));
			}
		}
	}
}
function isvip(&$aseco,$login)
{
	$time=time();
	if(isset($aseco->server->jfreu->vip_list[$login]))
	{
		if(($aseco->server->jfreu->vip_list[$login]==0 || $aseco->server->jfreu->vip_list[$login]>$time))
		{
			return 1;
		}
		else
		{
			unset($aseco->server->jfreu->vip_list[$login]);
		}
	}
	return 0;
}
function isunspec(&$aseco,$login)
{
	if($aseco->server->jfreu->playerlist[$login]->unspec==1)
	{
		return 1;
	}
	return 0;
}
function kick_player_spec(&$aseco,$login)
{
	if($aseco->server->jfreu->ranklimit==0)
	{
		return 0;
	}
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	if($aseco->server->jfreu->autorank==1)
	{
		$limit=$aseco->server->jfreu->autolimit;
	}
	if ($aseco->client->query('GetPlayerList', 200, 0))
	{
		$PlayerList = $aseco->client->getResponse();
		foreach ($PlayerList as $player)
		{
			if($aseco->server->jfreu->playerlist[$player['Login']]->speconly==1)
			{
				if($player['IsSpectator']!=1 && $player['LadderRanking']>$limit && $aseco->server->jfreu->playerlist[$player['Login']]->kicked==0)
				{
					if($clean_nick=clean_nick($player['NickName']))
					{
						$message=$yel.'>> '.$blu.'SpecOnly '.$whi.$clean_nick.$blu.' tried to join the race ['.$red.'kicked'.$blu.'].';
						$aseco->addCall("ChatSendServerMessage", array($message));
					}
					$aseco->addCall("Kick", array($player['Login']));
					$aseco->server->jfreu->playerlist[$player['Login']]->kicked=1;
					$aseco->server->jfreu->kicked++;
				}
			}
		}
	}
	else
	{
		$aseco->console("[Problem] client query failed (".$aseco->server->ip.":".$aseco->server->port.")");
	}
}
function isbanned(&$aseco,$login) // return min = banned , return 0 = not banned
{
	if($aseco->server->jfreu->playerlist[$login]->banned==0)
	{
		return 0;
	}
	$time=time();
	if($aseco->server->jfreu->playerlist[$login]->banned>$time)
	{
		return round((($aseco->server->jfreu->playerlist[$login]->banned)-$time)/60);
	}
	else
	{
		$aseco->server->jfreu->playerlist[$login]->banned=0;
		return 0;
	}
}
function banfor(&$aseco,$login,$time) // time : min
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	if($time>0)
	{
		$message =$yel.'>> '.$red.'You have been banned for '.$time.' minute(s).';
		$aseco->addCall("ChatSendServerMessageToLogin", array($message, $login));
		$aseco->addCall("Kick", array($login));
	}
	$time*=60;
	$time+=30;
	$absolute_time=time()+$time;
	$aseco->server->jfreu->playerlist[$login]->banned=$absolute_time;
}
function ajouter_joueur_liste(&$aseco,$joueur,$isvip,$speconly)
{
	if(!isset($aseco->server->jfreu->playerlist[$joueur->login]))
	{
		$aseco->server->jfreu->playerlist[$joueur->login]=new joueur();
		$aseco->server->jfreu->playerlist[$joueur->login]->badwords=0;
		$aseco->server->jfreu->playerlist[$joueur->login]->hasvoted=0;
		$aseco->server->jfreu->playerlist[$joueur->login]->kicked=0;
		$aseco->server->jfreu->playerlist[$joueur->login]->banned=0;
		$aseco->server->jfreu->playerlist[$joueur->login]->other_panel=0;
	}
	$aseco->server->jfreu->playerlist[$joueur->login]->speconly=$speconly;
	$aseco->server->jfreu->playerlist[$joueur->login]->isvip=$isvip;
	$aseco->server->jfreu->playerlist[$joueur->login]->newscore=0;
	$aseco->server->jfreu->playerlist[$joueur->login]->bill_challenge=-1;
}
function BadWords(&$aseco, $command)
{
	$player = $aseco->server->players->getPlayer($command[1]);
	$nick=$player->nickname;
	if($nick=='')
	{
		return -1;
	}
	if($aseco->server->jfreu->badwords==0)
	{
		return 0;
	}
	$texte=$propre=stripColors($command[2]);
	$texte=strtolower($texte);
	$texte=str_replace("|_|","u",$texte);
	$texte=ereg_replace("[^a-z ]","",$texte);
	$lettre="a";
	while($lettre<"z")
	{
		$texte=ereg_replace("[".$lettre."]{2,}",$lettre,$texte);
		$lettre++;
	}
	//echo $texte."\n";
	$max=$aseco->server->jfreu->badwordsnb;
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color;
	$bad_Words = array(	'putain','ptain','merde','fuck','cunt','fucker','fuckin','fucking',
						'wichs','fick','salop','siktirgit', 'shit','bordel','salope',
						'hitler', 'cock','faitchier','merda',
						'encul','sucks','conerie','batard','bastard','enculer','connard',
						'baskasle','baskasole','cocugu','kodugumun','cazo',
						'penis', 'fotze', 'maul', 'pula', 'pizda',
						'sugi', 'cacat', 'pisat', 'labagiu', 'gaozar',
						'orospu','bitch','pd','gay','puta');
	foreach($bad_Words As $mot)
	{
		if (ereg ("(^|[^a-z])".$mot."($|[^a-z])", $texte))
		{
			$aseco->server->jfreu->playerlist[$command[1]]->badwords++;
			$message = $yel.'>> '.$red.'Language plz !';
			if($aseco->server->jfreu->badwordsban==1 && $aseco->server->jfreu->playerlist[$command[1]]->badwords>$max)
			{
				$max2=$max*2;
				$message .= $blu.' ['.$whi.clean_nick($nick).$blu.' : ';
				$message .= $whi.$aseco->server->jfreu->playerlist[$command[1]]->badwords.$blu.'/'.$whi.$max2.$blu;
				$message.=$red.' to ban '.$blu.'] ';
			}
			else
			{
				$babar=$aseco->server->jfreu->playerlist[$command[1]]->badwords%max;
				$message .= $blu.' ['.$whi.clean_nick($nick).$blu.' : ';
				$message .= $whi.$aseco->server->jfreu->playerlist[$command[1]]->badwords.$blu.'/'.$whi.$max.$blu;
				$message.=$red.' to kick '.$blu.'] ';
			}
			$message2=$yel.'>> '.$col.'[ '.$whi.'"'.$mot.'"'.$col.' is a forbidden word ].';
			$aseco->addCall("ChatSendServerMessageToLogin", array($message2,$command[1]));
			if(($aseco->server->jfreu->playerlist[$command[1]]->badwords%$max)==0)
			{
				if($aseco->server->jfreu->badwordsban==1)
				{
					if($aseco->server->jfreu->playerlist[$command[1]]->badwords>$max)
					{
						banfor($aseco,$command[1],10);
						$message .=' ('.$red.'banned for 10 min'.$blu.')';
						$aseco->server->jfreu->playerlist[$command[1]]->badwords=0;
					}
					else
					{
						$aseco->addCall("Kick", array($command[1]));
						$message .=' ('.$red.'kicked'.$blu.') ';
					}
				}
				else
				{
					$aseco->addCall("Kick", array($command[1]));
					$message .=' ('.$red.'kicked'.$blu.') ';
					$aseco->server->jfreu->playerlist[$command[1]]->badwords=0;
				}
			}
			$aseco->addCall("ChatSendServerMessage", array($message));
			return 0;
		}
	}
}
function spec_message(&$aseco,$login)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$message=$yel.'>> '.$blu.'You are '.$whi.'SpecOnly'.$blu.', ask an admin to be unSpec.';
   	$aseco->addCall("ChatSendServerMessageToLogin", array($message, $login));
	$message2=$yel.'>> '.$blu.'Or use the '.$whi.'/unspec'.$blu.' command to launch a vote.';
   	$aseco->addCall("ChatSendServerMessageToLogin", array($message2, $login));
}
function vote_finish(&$aseco)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	
	if($aseco->server->jfreu->vote_item->type=='unspec')
	{
		$login=$aseco->server->jfreu->vote_item->login;
		$player=$aseco->server->players->getPlayer($login);
		$nick=$player->nickname;
		$rank=$player->ladderrank;
		
		$yes=$aseco->server->jfreu->vote_item->yes;
		$no=$aseco->server->jfreu->vote_item->no;
		$message=$yel.'>> '.$blu.'Vote result to unSpec '.$whi.clean_nick($nick).$blu.' : '.$whi.$yes.$blu.' yes, '.$whi.$no.$blu.' no';
		$aseco->addCall("ChatSendServerMessage", array($message));
		if($yes>$no)
		{
			$aseco->server->jfreu->playerlist[$login]->speconly=0;
			$aseco->server->jfreu->playerlist[$login]->unspec=1;
			$message=$yel.'>> '.$blu.'The server unSpecs '.$whi.clean_nick($nick).$blu.'.';
			$aseco->addCall("ChatSendServerMessage", array($message));
			if($aseco->server->jfreu->autorank==1)
			{
				autorank(&$aseco,$command);
			}
		}
		else
		{
			$message=$yel.'>> '.$blu.'The server banned '.$whi.clean_nick($nick).$blu.' for '.$whi.'5'.$blu.' min.';
			$aseco->addCall("ChatSendServerMessage", array($message));
			banfor($aseco,$login,5);
		}
	}
	$aseco->server->jfreu->vote_item->login='';
	$aseco->server->jfreu->vote_item->yes=0;
	$aseco->server->jfreu->vote_item->no=0;
	$aseco->server->jfreu->vote_item->total=0;
	$aseco->server->jfreu->current_vote=0;
	$aseco->server->jfreu->vote_item->nb_votes_needed=0;
	$aseco->server->jfreu->type='';
	foreach($aseco->server->players->player_list as $pl)
	{
		$aseco->server->jfreu->playerlist[$pl->login]->hasvoted=0;
	}
}
function new_vote(&$aseco,$type,$login) // type = unspec, round, timeattack...
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color;
	
	$aseco->server->jfreu->vote_item->login=$login;
	$aseco->server->jfreu->vote_item->yes=0;
	$aseco->server->jfreu->vote_item->no=0;
	$aseco->server->jfreu->vote_item->total=0;
	$aseco->server->jfreu->current_vote=1;
	$aseco->server->jfreu->vote_item->type=$type;
	
	$nbjoueurs=count($aseco->server->players->player_list);
	$aseco->server->jfreu->vote_item->nb_votes_needed=round(($nbjoueurs/4),0);
	
	$player=$aseco->server->players->getPlayer($login);
	$nick=$player->nickname;
	$rank=$player->ladderrank;
	if($type=='unspec')
	{
		$message=$yel.'>> '.$blu.'SpecOnly '.$whi.clean_nick($nick).$blu.'(rank:'.$whi.$rank.$blu.') wants to join the race.';
		$message2=$yel.'>> '.$col.'('.$gre.'/yes'.$col.' | '.$red.'/no'.$col.') : '.$whi.round($aseco->server->jfreu->vote_item->nb_votes_needed,0).$col.' votes needed.';
		$aseco->addCall("ChatSendServerMessage", array($message));
		$aseco->addCall("ChatSendServerMessage", array($message2));
	}
	foreach($aseco->server->players->player_list as $pl)
	{
		$aseco->server->jfreu->playerlist[$pl->login]->hasvoted=0;
	}
}
function vote_yes_no(&$aseco,$yes,$change) // change = 1 : Vote change (yes -> no | no -> yes)
{
	if($aseco->server->jfreu->vote_item->nb_votes_needed==0)
	{
		vote_end(&$aseco);
		return 0;
	}
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color;
	if($yes==1)
	{
		$aseco->server->jfreu->vote_item->yes++;
		if($change==1)
		{
			$aseco->server->jfreu->vote_item->no--;
		}
	}
	else
	{
		$aseco->server->jfreu->vote_item->no++;
		if($change==1)
		{
			$aseco->server->jfreu->vote_item->yes--;
		}
	}
	if($change==0)
	{
		$aseco->server->jfreu->vote_item->total++;
	}
	$reste=$aseco->server->jfreu->vote_item->nb_votes_needed-$aseco->server->jfreu->vote_item->total;
	if($reste==0 || $aseco->server->jfreu->vote_item->yes>($aseco->server->jfreu->vote_item->nb_votes_needed/2) || $aseco->server->jfreu->vote_item->no>($aseco->server->jfreu->vote_item->nb_votes_needed/2))
	{
		vote_finish($aseco);
		$aseco->server->jfreu->current_vote=0;
		return 1;
	}
	else
	{
		if($aseco->server->jfreu->vote_item->type=='unspec')
		{
			$player=$aseco->server->players->getPlayer($aseco->server->jfreu->vote_item->login);
			$nick=$player->nickname;
			$rank=$player->ladderrank;
			$message=$yel.'>> '.$whi.$reste.$col.' more votes needed to unSpec '.$whi.clean_nick($nick).$col.'$n [ '.$gre.'$n/yes'.$col.'$n | '.$red.'$n/no'.$col.'$n ].';
		}
		$aseco->addCall("ChatSendServerMessage", array($message));
	}
}
function vote_end(&$aseco)
{
	if($aseco->server->jfreu->current_vote==1)
	{
		$aseco->server->jfreu->vote_item->login='';
		$aseco->server->jfreu->vote_item->yes=0;
		$aseco->server->jfreu->vote_item->no=0;
		$aseco->server->jfreu->vote_item->total=0;
		$aseco->server->jfreu->vote_item->type='';
		$aseco->server->jfreu->vote_item->nb_votes_needed=0;
		$aseco->server->jfreu->current_vote=0;
	}
}
function read_guest_list(&$aseco)
{
	if ($aseco->client->query('GetGuestList', 50, 0))
	{
		$GuestList = $aseco->client->getResponse();
		foreach ($GuestList as $player)
		{
			if(!isset($aseco->server->jfreu->vip_list[$player['Login']]))
			{
				$aseco->server->jfreu->vip_list[$player['Login']]=0;
			}
		}
	}
}
function write_guest_list(&$aseco)
{
	if(count($aseco->server->jfreu->vip_list)>0)
	{
		foreach($aseco->server->jfreu->vip_list as $login=>$exp)
		{
			$aseco->addCall('AddGuest',array($login));
		}
	}	
}
function clean_guest_list(&$aseco)
{
	$aseco->addCall('CleanGuestList');
}
function add_guest(&$aseco,$login)
{
	$aseco->addCall('AddGuest', array($login));
}
function remove_guest(&$aseco,$login)
{
	$aseco->addCall('RemoveGuest', array($login));
}
function read_lists_xml(&$aseco)
{
	$file='./plugins/jfreu/jfreu.lists.xml';
	if(!file_exists($file))
	{
		$aseco->console("[ERROR] can't find : plugins/jfreu/jfreu.lists.xml");
		return -1;
	}
	$list=$aseco->xml_parser->parseXml($file);
	$admins=$list['LISTS']['ADMIN_LIST'][0];
	$vip=$list['LISTS']['VIP_LIST'][0];
	$team_vip=$list['LISTS']['TEAM_VIP_LIST'][0];
	// UPDATE ADMIN LIST
	if(isset($admins['LOGIN']))
	{
		$j=count($aseco->admin_list["TMLOGIN"]);
		for ($i = 0; $i < count($admins['LOGIN']); $i++)
		{
			if(!in_array($admins['LOGIN'][$i], $aseco->admin_list["TMLOGIN"]))
			{
				$aseco->admin_list["TMLOGIN"][$j]=$admins['LOGIN'][$i];
				$j++;
			}
		}
	}
	// Get vip_list
	if(isset($vip['VIP']))
	{
		$j=0;
		while($j<count($vip['VIP']))
		{
			$vipj=$vip['VIP'][$j];
			$login=$vip['VIP'][$j]['LOGIN'][0];
			$server_id=$vip['VIP'][$j]['SERVER_ID'][0];
			$expiration=$vip['VIP'][$j]['EXPIRATION'][0];
			if(!isset($vip_list[$login]))
			{
				if($expiration=="")
				{
					$expiration=0;
				}
			}
			if(!isset($aseco->server->jfreu->vip_list[$login]))
			{
				$aseco->server->jfreu->vip_list[$login]=$expiration;
			}
			$j++;
		}
	}
	// UPDATE VIP_TEAM_LIST
	if(isset($team_vip['TEAM']))
	{
		$j=0;
		for ($i = 0; $i < count($team_vip['TEAM']); $i++)
		{
			if(!in_array($team_vip['TEAM'][$i], $aseco->server->jfreu->team_vip_list))
			{
				$aseco->server->jfreu->team_vip_list[$j]=$team_vip['TEAM'][$i];
				$j++;
			}
		}
	}
}
function write_lists_xml(&$aseco)
{
	$lists="<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n<lists>\n\t<admin_list>\n";
	$nb=count($aseco->admin_list["TMLOGIN"]);
	$i=0;
	while($i<$nb)
	{
		if($aseco->admin_list["TMLOGIN"][$i]!='')
		{
			$lists.="\t\t<login>".$aseco->admin_list["TMLOGIN"][$i]."</login>\n";
		}
		$i++;
	}
	$lists.="\t</admin_list>\n\t<vip_list>\n";
	$time=time();
	foreach($aseco->server->jfreu->vip_list as $login=>$time_vip)
	{
		$time_merdique=$time_vip+1;
		if($time_merdique==1)
		{
			$time_merdique=0;
		}
		if($login!='' && ($time_vip==0 || $time_vip>$time))
		{
			$lists.="\t\t<vip>\n\t\t\t<login>".$login."</login>\n\t\t\t<expiration>".$time_merdique."</expiration>\n\t\t</vip>\n";
		}
	}
	$lists.="\t</vip_list>\n\t<team_vip_list>\n";
	$nb=count($aseco->server->jfreu->team_vip_list);
	$i=0;
	while($i<$nb)
	{
		if($aseco->server->jfreu->team_vip_list[$i]!='')
		{
			$lists.="\t\t<team>".$aseco->server->jfreu->team_vip_list[$i]."</team>\n";
		}
		$i++;
	}
	$lists.="\t</team_vip_list>\n</lists>";
	//** ECRITURE DU FICHIER XML **//
	$file = fopen('plugins/jfreu/jfreu.lists.xml', 'w+');
	if(!$file)
	{
		$aseco->console('[ERROR] can\'t write plugins/jfreu/jfreu.lists.xml');
		return -1;
	}
	fputs($file,$lists);
	fclose($file);
}
function up_to_date(&$aseco)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	if(($last=read_net_file("http://".$aseco->server->jfreu->net_server.'/plugin/versiontmu.php')) && !get_error($last))
	{
		if($last==$aseco->server->jfreu->version)
		{
			$message=$yel.'>> '.$blu.'Your Jfreu\'s plugin version is up to date';
			return $message;
		}
		else
		{
			$message=$yel.'>> '.$blu.'New version of Jfreu\'s plugin avilable : '.$gre.$last.$blu.".\n";
			$message.=$yel.'>> '.$red.'http://jfreu.servegame.com';
			return $message;
		}
	}
	else
	{
		$message=$yel.'>> '.$red.'Error : can\'t find the last version.';
		return $message;
	}
}
function novotemessage($aseco)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	if($aseco->server->jfreu->novote==1)
	{
		$message=$yel.'>> '.$blu.'Vote canceled.';
		$aseco->addCall("ChatSendServerMessage", array($message));
	}
}
function cancelvote($aseco)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$aseco->addCall("CancelVote");
	$message=$yel.'>> '.$blu.'Vote canceled.';
	$aseco->addCall("ChatSendServerMessage", array($message));
}
function kickworst(&$aseco,$x)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$i=0;
	if(count($aseco->server->players->player_list)==0)
	{
		return 0;
	}
	foreach($aseco->server->players->player_list as $pl)
	{
		if(true)//isvip(&$aseco,$pl->login)==0)
		{
			if(!isset($pl->ladderrank) || $pl->ladderrank==0)
			{
			}
			else
			{
				$i=0;
				while($i<count($listakicker))
				{
					$player_list=$aseco->server->players->getPlayer($listakicker[$i]);
					if($pl->ladderrank > $player_list->ladderrank)
					{
						$listakicker[$i]=$pl->login;
						$pl=$player_list;
					}
					$i++;
				}
				$listakicker[$i]=$pl->login;
				$i++;
			}
		}
	}
	$nombre_de_joueurs=count($listakicker);
	if($x>$nombre_de_joueurs)
	{
		$x=$nombre_de_joueurs;
	}
	if($x==0)
	{
		$message=$yel.'>> '.$red.'No kick !';
		$aseco->addCall("ChatSendServerMessage", array($message));
		return 0;
	}
	$i=0;
	$aseco->server->jfreu->playerlist[$listakicker[$i]]->kicked=1;
	$playertemp=$aseco->server->players->getPlayer($listakicker[$i]);
	$nicknames=$whi.clean_nick($playertemp->nickname);
	//$ranks=$whi.'[DEBUG] RANKS : | '.$playertemp->ladderrank.' | ';
	kicker_login($aseco,$listakicker[$i]);
	$i++;
	while($i<$x)
	{
		$playertemp=$aseco->server->players->getPlayer($listakicker[$i]);
		$nicknames.=$blu.', '.$whi.clean_nick($playertemp->nickname);	
		//$ranks.=$playertemp->ladderrank.' | ';
		$aseco->server->jfreu->playerlist[$listakicker[$i]]->kicked=1;
		kicker_login($aseco,$listakicker[$i]);
		$i++;
	}
	$message=$yel.'>> '.$blu.'Players : '.$nicknames.$red.' kicked'.$blu.'.';
	$aseco->addCall("ChatSendServerMessage", array($message));
	//$aseco->addCall("ChatSendServerMessage", array($ranks));
	if($aseco->server->jfreu->autorank==1)
	{
		autorank(&$aseco,$x);
	}
	return $x;
}
function novote($aseco)
{
	if($aseco->server->jfreu->novote==1)
	{
		$aseco->addCall("CancelVote");
	}
}
function player_disconnect(&$aseco,$command)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	cancel_vote($aseco,$command->login);
	if($aseco->server->jfreu->playerlist[$command->login]->kicked==0 && $clean_nick=clean_nick($command->nickname))
	{
		$message=$yel.'>> '.$whi.$clean_nick.$blu.' has left the game.';
		$aseco->addCall("ChatSendServerMessage", array($message));
		if($aseco->server->jfreu->autorank==1 && $aseco->server->jfreu->playerlist[$command->login]->speconly==0)
		{
			autorank(&$aseco,$command);
		}
	}
	//unset($aseco->server->jfreu->playerlist[$command->login]);
}
function player_connect(&$aseco,$command)
{
	$aseco->server->jfreu->playerlist[$command->login]->panel=1;
	if(!$aseco->settings['welcome_msg_window'])
	{
		jfreu_display($aseco,$command->login);
	}
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$welcome=$yel.'>> '.$whi.'Jfreu'.$blu.'\'s plugin '.$gre.$aseco->server->jfreu->version.$blu.' : '.$whi.'Loaded'.$blu.'.';
	$aseco->addCall("ChatSendServerMessageToLogin", array($welcome, $command->login));
	$login=$command->login;
	if($ban=isbanned(&$aseco,$command->login))
	{
		if($clean_nick=clean_nick($command->nickname))
		{
			$message=$yel.'>> '.$blu.'New Player : '.$whi.$clean_nick.$blu.' Rank : '.$whi.$command->ladderrank.$blu.' ['.$red.'Banned for '.round($ban,0).' min'.$blu.'] Nation : '.$whi.get_nation(&$aseco,$login).$blu.'.';
			$aseco->addCall("ChatSendServerMessage", array($message));
		}
		$message2=$yel.'>> '.$red.'Your ban will be over in '.$whi.round($ban,0).$red.' min.';
		$aseco->addCall("ChatSendServerMessageToLogin", array($message2, $command->login));
		$aseco->server->jfreu->playerlist[$command->login]->kicked=1;
		$aseco->addCall("Kick", array($command->login));
		return 0;
	}
	if($aseco->server->jfreu->ranklimit==1)
	{
		if(autokick(&$aseco,$command) && $aseco->server->jfreu->autorank==1 && $command->isspectator==0)
		{
			autorank(&$aseco,$command);
		}
	}
	else
	{
		if($clean_nick=clean_nick($command->nickname))
		{
			$message=$yel.'>> '.$blu.'New Player : '.$whi.$clean_nick.$blu.' Rank : '.$whi.$command->ladderrank.$blu.' Nation : '.$whi.get_nation(&$aseco,$login).$blu.'.';
			$aseco->addCall("ChatSendServerMessage", array($message));
		}
		ajouter_joueur_liste($aseco,$command,0,0);
	}
}
function addJfreuAdminChatCommand(&$aseco,$name,$help)
{
	$i=count($aseco->server->jfreu->jfreu_admin_commands);
	$aseco->server->jfreu->jfreu_admin_commands[$i]=new jfreu_command();
	$aseco->server->jfreu->jfreu_admin_commands[$i]->name=$name;
	$aseco->server->jfreu->jfreu_admin_commands[$i]->help=$help;	
}
function warn_login(&$aseco,$login)
{
	$message=$aseco->server->jfreu->warning;
	$aseco->addCall("ChatSendServerMessageToLogin", array($message, $login));
}
function add_remove_vip(&$aseco,$login,$nick)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color;
	if(isset($aseco->server->jfreu->vip_list[$login]))
	{
		unset($aseco->server->jfreu->vip_list[$login]);
		remove_guest(&$aseco,$login);
		write_lists_xml(&$aseco);
		$message=$yel.'>> '.$blu.'Admin removed '.$whi.clean_nick($nick).$blu.' from VIP list.';
		$aseco->addCall("ChatSendServerMessage", array($message));
		return -1;
	}
	$aseco->server->jfreu->vip_list[$login]=0;
	add_guest($aseco,$login);
	write_lists_xml($aseco);
	$message=$yel.'>> '.$blu.'Admin added '.$whi.clean_nick($nick).$blu.' in VIP list.';
	$aseco->addCall("ChatSendServerMessage", array($message));
}
function add_remove_admin(&$aseco,$login,$nick)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color;
	if(in_array($login, $aseco->admin_list['TMLOGIN']))
	{
		$nb=count($aseco->admin_list['TMLOGIN']);
		$i=0;
		while($aseco->admin_list['TMLOGIN'][$i]!=$login && $i<$nb)
		{
			$i++;
		}
		$aseco->admin_list['TMLOGIN'][$i]='';
		write_lists_xml(&$aseco);
		$message=$yel.'>> '.$blu.'Admin removed '.$whi.clean_nick($nick).$blu.' from admin list.';
		$aseco->addCall("ChatSendServerMessage", array($message));
		return -1;
	}
	$i=count($aseco->admin_list['TMLOGIN']);
	$aseco->admin_list['TMLOGIN'][$i]=$login;
	write_lists_xml(&$aseco);
	$message=$yel.'>> '.$blu.'Admin added '.$whi.clean_nick($nick).$blu.' in admin list.';
	$aseco->addCall("ChatSendServerMessage", array($message));
}
function bet_buy_ticket(&$aseco,$login_bet,$login_buy,$quantite)
{
	if(!bet_bettime($aseco))
	{
		return 0;
	}
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color; 
	$nb=count($aseco->server->jfreu->bet_list);
	$aseco->server->jfreu->bet_list[$nb]=new ticket();
	$aseco->server->jfreu->bet_list[$nb]->login_buyer=$login_buy;
	$aseco->server->jfreu->bet_list[$nb]->login_bet=$login_bet;
	$aseco->server->jfreu->bet_list[$nb]->paid=0;
	$aseco->server->jfreu->bet_list[$nb]->nb=$quantite;
	$aseco->server->jfreu->bet_list[$nb]->billid=bet_send_bill(&$aseco,$login_buy,$aseco->server->jfreu->ticketvalue*$quantite);
}
function bet_pay_winners(&$aseco,$winner_login)
{
	//** colors **//
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color; 
	
	if(count($aseco->server->jfreu->bet_list)==0)
	{
		return 0;
	}
	
	//** init **//
	$nb_tickets=0; // tickets
	$winners=0; // ticket_winners
	$winners_players=0;
	$nb_bets=0; // tickets*nb_ticket
	$cash=$aseco->server->jfreu->betjackpot; // jackpot
	$race_winner=$aseco->server->players->getPlayer($winner_login);
	//bet_pay_authorpercent($aseco,"","");
	
	//** player_bets **//  $player_xxx[login]=nb_xxx_ticket;
	$player_win=array();
	$player_lose=array();
	
	//** nb_tickets **//
	foreach($aseco->server->jfreu->bet_list as $bet)
	{
		if($bet->paid==1)
		{
			$nb_tickets++;
		}
	}
	
	//** count + $players_bet array**//
	foreach($aseco->server->jfreu->bet_list as $ticket)
	{
		if($ticket->paid==1)
		{
			if($ticket->login_bet==$winner_login) // win
			{
				$winners+=$ticket->nb;
				$winners_players++;
				$player_login=$ticket->login_buyer;
				if(isset($player_win[$ticket->login_buyer]))
				{
					$player_win[$ticket->login_buyer]+=$ticket->nb;
				}
				else
				{
					$player_win[$ticket->login_buyer]=$ticket->nb;
				}
			}
			else // lose
			{
				if(isset($player_lose[$ticket->login_buyer]))
				{
					$player_lose[$ticket->login_buyer]+=$ticket->nb;
				}
				else
				{
					$player_lose[$ticket->login_buyer]=$ticket->nb;
				}
			}
			$nb_bets+=$ticket->nb;
		}
	}
	//** count winner_players **//
	$winners_players=count($player_win);
	
	//** no bet_winner **//
	if($winners_players==0)
	{
		//$money=floor($cash);
		$message=$yel.">> ".$blu."Bet result : ".$red."No winner";
		$aseco->addCall("ChatSendServerMessage", array($message));
		bet_updateminipanel(&$aseco);
		return 0;
	}
	$win_amount=$cash/$winners; // = coppers/win ticket
	
	//** message 1 winner **//
	if($winners_players==1)
	{
		$money=floor($win_amount);
		$joueur=$aseco->server->players->getPlayer($player_login);
		$nick=$joueur->nickname;
		//echo "money : ".$money."\n";
		$message=$yel.">> ".$blu."Bet result : ".$whi.clean_nick($nick).$blu." wins ".$gre.$cash.$blu." copper(s) !";
		$aseco->addCall("ChatSendServerMessage", array($message));
	}
	
	//** message more than 1 winner **//
	else
	{
		$money=floor($win_amount);
		//echo "money : ".$money."\n";
		$message=$yel.">> ".$blu."Bet result : ".$whi.$winners_players.$blu." winners, ".$gre.$cash.$blu." coppers.";
		$aseco->addCall("ChatSendServerMessage", array($message));
	}
	
	//** message to winner + pay **//
	foreach($player_win as $login => $nb_tickets)
	{
		$money_to_player=floor($win_amount*$nb_tickets);
		bet_pay_betwinner($aseco,$login,$money_to_player);
		$message=$yel.">> ".$blu."You won your bet : ".$whi.$money_to_player.$blu." copper(s).";
		$aseco->addCall("ChatSendServerMessageToLogin", array($message, $login));
	}
	
	//** message to losers **//
	foreach($player_lose as $login => $nb_tickets)
	{
		if(!isset($player_win[$login]))
		{
			$message=$yel.">> ".$blu."You lost your bet.";
			$aseco->addCall("ChatSendServerMessageToLogin", array($message, $login));
		}
	}
	
	bet_reset_bets($aseco);
	bet_updateminipanel($aseco);
}
function bet_send_bill(&$aseco,$login,$amount)
{
	//$aseco->addCall("SendBill", array($login,$amount,"Bet",""),$login."_bet",false);
	$aseco->client->query("SendBill",$login,$amount,"Bet","");
	$betID = $aseco->client->getResponse();
	return $betID;
}
function bet_pay_racewinner(&$aseco,$login,$amount)
{
	if($amount>0)
	{
		settype($amount,'integer');
		$aseco->addCall("Pay", array($login,$amount,'Coppers won [Jfreu\'s plugin] race winner'));
	}
}
function bet_pay_betwinner(&$aseco,$login,$amount)
{
	if($amount>0)
	{
		settype($amount,'integer');
		$aseco->addCall("Pay", array($login,$amount,'Coppers won [Jfreu\'s plugin] bet winner'));
	}
}
function bet_bettime(&$aseco) // return true : ok | false : finished
{
	$ecoule=time()-$aseco->server->jfreu->timerace;
	if($ecoule<$aseco->server->jfreu->bettime)
	{
		return true;
	}
	return false;
}
function bet_add_betjackpot(&$aseco,$coppers)
{
	$aseco->server->jfreu->betjackpot+=$coppers;
}
function bet_set_betjackpot(&$aseco,$percent) //% for bet winner + bets
{
	if($percent>0 && $percent<=50)
	{
		$coppers=get_coppers($aseco);
		$aseco->server->jfreu->betjackpot=floor(($percent*$coppers)/100);
		return 1;
	}
	else
	{
		$aseco->server->jfreu->betjackpot=0;
		return 0;
	}
}
function bet_set_winjackpot(&$aseco,$percent) //% for race winner
{
	if($percent>0 && $percent<=50)
	{
		$coppers=get_coppers($aseco);
		$aseco->server->jfreu->winjackpot=floor(($percent*$coppers)/100);
		return 1;
	}
	else
	{
		$aseco->server->jfreu->winjackpot=0;
		return 0;
	}
}
function bet_bill_update(&$aseco,$bill)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color;
	$billid=$bill[0];
	$state=$bill[1];
	$statename=$bill[2];
	$transactionid=$bill[3];
	if($state!=4)
	{
		if($state==5)
		{
			// not paid
			return 0;
		}
	}
	else
	{
		foreach($aseco->server->jfreu->bet_list as $ticket)
		{
			if($ticket->billid==$billid && $ticket->paid==0)
			{
				$ticket->paid=1;
				$player = $aseco->server->players->getPlayer($ticket->login_bet);
				$nick=$player->nickname;
				$message=$yel.">> ".$blu."You have bet ".$whi.($ticket->nb*$aseco->server->jfreu->ticketvalue).$blu." copper(s) on ".$whi.clean_nick($nick).$blu.".";
				bet_add_betjackpot($aseco,$ticket->nb*$aseco->server->jfreu->ticketvalue);
				bet_updateminipanel($aseco);
				$aseco->addCall("ChatSendServerMessageToLogin", array($message, $ticket->login_buyer));
				return 1;
			}
		}
	}
	return 0;
}
function get_coppers(&$aseco) // TODO TODO
{
	if (!$aseco->client->query('GetServerCoppers'))
	{
		$aseco->console("[Problem] client query failed (".$aseco->server->ip.":".$aseco->server->port.")");
		return 0;
	}
	if($aseco->server->jfreu->bank==1)
	{
		return ($aseco->client->getResponse()-challenge_get_bank($aseco));
	}
	return $aseco->client->getResponse();
}
function bet_updateminipanel(&$aseco)
{
	foreach($aseco->server->players->player_list as $pl)
	{
		if($aseco->server->jfreu->playerlist[$pl->login]->panel==1 && $aseco->server->jfreu->playerlist[$pl->login]->other_panel==0)
		{
			jfreu_minipanel($aseco,$pl->login);
		}
	}
}
function hide_minipanel(&$aseco)
{
	foreach($aseco->server->players->player_list as $pl)
	{
		if($aseco->server->jfreu->playerlist[$pl->login]->panel==1 && $aseco->server->jfreu->playerlist[$pl->login]->other_panel==0)
		{
			$aseco->server->jfreu->playerlist[$pl->login]->panel=0;
			jfreu_minipanel($aseco,$pl->login);
		}
	}
}
function sort_playerlist(&$aseco)
{
	$id=array();
	$name=array();
	foreach ($aseco->server->players->player_list as $key => $row)
	{
	   $id[$key]  = $row->ID;
	   //strtolower to disable sorting upper/lowercase
	   $name[$key] = clean_nick(strtolower($row->nickname));
	}

	//Sort first for "name" then "id"
	array_multisort($name, SORT_ASC, $id, SORT_ASC, $aseco->server->players->player_list);
}
function pay_server(&$aseco,$login,$amount)
{
	if($amount>0)
	{
		settype($amount,'integer');
		$aseco->addCall("SendBill", array($login,$amount,"Donation from ".$login,""));
	}
}
function pay_jfreu(&$aseco,$login,$amount)
{
	if($amount>0)
	{
		settype($amount,'integer');
		$aseco->addCall("SendBill", array($login,$amount,"Donation from ".$login,"jfreu"));
	}
}
function pay_owner(&$aseco,$login,$amount)
{
	if($amount>0)
	{
		settype($amount,'integer');
		$aseco->addCall("SendBill", array($login,$amount,"Donation from ".$login,$aseco->server->jfreu->ownerLogin));
	}
}
function reset_pay_winner(&$aseco)
{
	if($aseco->server->jfreu->jackpotminplayer>count($aseco->server->players->player_list) || $aseco->server->jfreu->paywinner==0)
	{
		bet_set_winjackpot($aseco,0);
	}
	else
	{
		bet_set_winjackpot($aseco,$aseco->server->jfreu->winpercent);
	}
	bet_updateminipanel($aseco);
}
function bet_reset_bets(&$aseco)
{
	unset($aseco->server->jfreu->bet_list);
	$aseco->server->jfreu->bet_list=array();
	if($aseco->server->jfreu->jackpotminplayer>count($aseco->server->players->player_list))
	{
		bet_set_betjackpot($aseco,0);
	}
	else
	{
		bet_set_betjackpot($aseco,$aseco->server->jfreu->betpercent);
	}
	bet_updateminipanel($aseco);
}
function is_spectator(&$aseco,$login)
{
	if (!$aseco->client->query('GetPlayerInfo',$login))
	{
		$aseco->console("[Problem] client query failed (".$aseco->server->ip.":".$aseco->server->port.")");
		return false;
	}
	$player_infos=$aseco->client->getResponse();
	$spec=$player_infos['IsSpectator'];
	if($spec==1)
	{
		return true;
	}
	return false;
}
function chat_debug(&$aseco,$command)
{
	$login=$command['author']->login;
	if($aseco->isAdmin($login))
	include("jfreu.debug.php");
}
function challenge_is_registered(&$aseco)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color; 
	if(!is_file('plugins/jfreu/server_key.cfg') || !($key=read_file('plugins/jfreu/server_key.cfg')))
	{
		// no key avilable --> register server on master server
		$name=nick_to_http(get_server_name($aseco));
		$login=get_server_login($aseco);
		$request="http://".$aseco->server->jfreu->net_server.'/weekChallenge/index.php?register&name='.$name.'&login='.$login;
		if(!($key=read_net_file($request)) || get_error($key))
		{
			// error cannot register on main server (already registered | master server down | server banned from challenges)
			if($aseco->server->jfreu->weekchallenge_on==1)
			{
				echo "[Challenge] server registration : FAILED\n";
				$message=$yel.">> ".$col."Error#1 registering on weekChallenge, weekChallenge ".$red."disabled".$col.".";
				$aseco->addCall("ChatSendServerMessage", array($message));
				$aseco->server->jfreu->weekchallenge_on=0;
			}
			reset_challenges($aseco);
			return 0;
		}
		$file = fopen('plugins/jfreu/server_key.cfg', 'w+');
		fputs($file,$key);
		fclose($file);
	}
	$aseco->server->jfreu->server_key=$key;
	
	// server registered for challenge ? (and is this server the challenges_bank ?)
	$request="http://".$aseco->server->jfreu->net_server.'/weekChallenge/index.php?key='.$key.'&isregistered';
	if(!($status=read_net_file($request)) || get_error($status))
	{
		// error cannot get registration status (master server down | server banned from challenges)
		if($aseco->server->jfreu->weekchallenge_on==1)
		{
			echo "[Challenge] server registration : ERROR\n";
			$message=$yel.">> ".$col."Error#2 registering on weekChallenge, weekChallenge ".$red."disabled".$col.".";
			$aseco->addCall("ChatSendServerMessage", array($message));
			$aseco->server->jfreu->weekchallenge_on=0;
		}
		reset_challenges($aseco);
		return 0;
	}
	$statuses=explode("|",$status);
	$aseco->server->jfreu->bank=$statuses[0];
	if($statuses[1]==0)
	{
		// error server is not registered for challenges
		echo "[Challenge] server registration : FAILED\n";
		$message=$yel.">> ".$col."Error#3 registering on weekChallenge, weekChallenge ".$red."disabled".$col.".";
		$aseco->addCall("ChatSendServerMessage", array($message));
		$aseco->server->jfreu->weekchallenge_on=0;
		reset_challenges($aseco);
		return 0;
	}
	$aseco->server->jfreu->challenge=1;
	echo "[Challenge] server registration : OK\n";
	return 1;
}
function challenge_read_ban_list(&$aseco)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color; 
	if($aseco->server->jfreu->challenge==0 && challenge_is_registered(&$aseco)==0)
	{
		return 0;
	}
	//get challenges
	$request="http://".$aseco->server->jfreu->net_server.'/weekChallenge/index.php?key='.$aseco->server->jfreu->server_key.'&getbanlist';
	if(!($banlist=read_net_file($request)) || get_error($banlist))
	{
		echo "[Challenge] Get BanList : Failed\n";
		return 0;
	}
	$banned=explode("|",$banlist);
	$i=0;
	$aseco->server->jfreu->challenge_ban_list=array();
	while($i<count($banned))
	{
		$aseco->server->jfreu->challenge_ban_list[$i]=$banned[$i];
		$i++;
	}
	echo "[Challenge] Get BanList : OK\n";
}
function challenge_is_banned(&$aseco,$login) // return 1 or 0 (1 = banned , 0 = not banned)
{
	if(empty($aseco->server->jfreu->challenge_ban_list))
	{
		return 0;
	}
	foreach($aseco->server->jfreu->challenge_ban_list as $banned)
	{
		if($banned==$login)
		{
			return 1;
		}
	}
	return 0;
}
function jfreu_load_challenges(&$aseco) // registered : return 1 || error : return 0
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color; 
	if($aseco->server->jfreu->challenge==0 && challenge_is_registered(&$aseco)==0)
	{
		return 0;
	}
	//get challenges
	$request="http://".$aseco->server->jfreu->net_server.'/weekChallenge/index.php?key='.$aseco->server->jfreu->server_key.'&getchallenges';
	if(!($challenges=read_net_file($request)) || get_error($challenges))
	{
		// error cannot get challenges list
		if($aseco->server->jfreu->weekchallenge_on==1 && $aseco->server->jfreu->challenge==0)
		{
			echo "[Challenge] challenges list request : FAILED\n";
			$message=$yel.">> ".$col."Can't get the challenges list, weekChallenge ".$red."disabled".$col.".";
			$aseco->addCall("ChatSendServerMessage", array($message));
		}
		if($aseco->server->jfreu->challenge==0) // if challenge not already loaded (no update)
		{
			reset_challenges($aseco);
		}
		return 0;
	}
	$challenge=explode("|", $challenges);
	$i=0;
	// create all challenges
	while($i<count($challenge))
	{
		//do not delete if challenge aldeady exists (update)
		if(!isset($aseco->server->jfreu->challenge_list[$i]) || $aseco->server->jfreu->challenge_list[$i]->id!=$challenge[$i])
		{
			$aseco->server->jfreu->challenge_list[$i]=new jfreu_challenge($challenge[$i]);
		}
		$i++;
	}
	// delete strange challenges
	while(isset($aseco->server->jfreu->challenge_list[$i]))
	{
		unset($aseco->server->jfreu->challenge_list[$i]);
		$i++;
	}
	echo "[Challenge] Challenges list : OK\n";
	// get all challenges infos + challengers infos
	foreach($aseco->server->jfreu->challenge_list as $challenge)
	{
		if(get_challengeinfo($aseco,$challenge)==1)
		{
			get_challengersinfo($aseco,$challenge->challengers,$challenge->id,$challenge->update);
		}
	}
	echo "[Challenge] Challenges infos : OK\n";
	challenge_read_ban_list(&$aseco);
	return 1;
}
function get_challengeinfo(&$aseco,&$challenge)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color;
	
	$challengeID=$challenge->id;
	$request="http://".$aseco->server->jfreu->net_server.'/weekChallenge/index.php?key='.$aseco->server->jfreu->server_key.'&getchallengeinfo&id='.$challengeID;
	if(!($challengeinfo=read_net_file($request)) || get_error($challengeinfo))
	{
		// error cannot get challenge info list
		if($aseco->server->jfreu->weekchallenge_on==1)
		{
			echo "[Challenge] challenge#".$challengeID." infos request : FAILED\n";
			$message=$yel.">> ".$col."Error requesting a challenge info, weekChallenge ".$red."disabled".$col.".";
			$aseco->addCall("ChatSendServerMessage", array($message));
		}
		reset_challenge($challenge);
		return 0;
	}
	$infos=explode("|",$challengeinfo);
	if( $infos[8]<time())
	{
		$challenge->status=1;
	}
	else
	{
		$challenge->status=$infos[0];
	}
	$challenge->name=$infos[1];
	$challenge->trackuid=$infos[2];
	$challenge->environment=$infos[3];
	$challenge->trackname=$infos[4];
	$challenge->trackauthor=$infos[5];
	$challenge->jackpot=$infos[6];
	$challenge->price=$infos[7];
	$challenge->endTime=$infos[8];
	$challenge->wcInfo=$infos[9];
	//echo "[Challenge] challenge#".$challengeID." infos request : OK\n";
	return 1;
}
function get_challengersinfo(&$aseco,&$challengers,$challengeID,&$update)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color;
	
	$request="http://".$aseco->server->jfreu->net_server.'/weekChallenge/index.php?key='.$aseco->server->jfreu->server_key.'&getchallengersinfo&id='.$challengeID;
	if(!($challengersinfo=read_net_file($request)) || get_error($challengersinfo))
	{
		if($challengersinfo=="")
		{
			$update=time();
			//echo "[Challenge] challenge#".$challengeID." challengers request : OK (no challenger)\n";
			return 1;
		}
		// error cannot get challengers list | no challenger
		if($aseco->server->jfreu->weekchallenge_on==1)
		{
			echo "[Challenge] challenge#".$challengeID." challengers request : FAILED\n";
		}
		return 0;
	}
	$infos=explode("|",$challengersinfo);
	$challengers=array();
	foreach($infos as $info)
	{
		$temp=explode(":",$info);
		$challengers[$temp[0]]=$temp[1];
	}
	$update=time();
	//echo "[Challenge] challenge#".$challengeID." challengers request : OK\n";
	return 1;
}
function get_server_login(&$aseco)
{
	if (!$aseco->client->query('GetSystemInfo'))
	{
		$aseco->console("[Problem] client query failed (".$aseco->server->ip.":".$aseco->server->port.")");
	}
	$systemInfo = $aseco->client->getResponse();
	return $systemInfo['ServerLogin'];
}
function get_server_name(&$aseco)
{
	if (!$aseco->client->query('GetServerOptions'))
	{
		$aseco->console("[Problem] client query failed (".$aseco->server->ip.":".$aseco->server->port.")");
	}
	$systemInfo = $aseco->client->getResponse();
	return $systemInfo['Name'];
}
function reset_challenge(&$challenge)
{
	unset($challenge);
}
function reset_challenges(&$aseco)
{
	$aseco->server->jfreu->weekchallenge=0;
	$aseco->server->jfreu->challenge_list=array();
	$aseco->server->jfreu->challenge_ban_list=array();
}
function get_error($txt)
{
	if(stristr($txt,"ERROR"))
		return true;
	return false;
}
function read_file($request) // ok : return string || error : return false
{
	$handle = @fopen($request, "rb");
	if(!$handle)
	{
		return "ERROR";
	}
	$contents = '';
	while (!feof($handle))
	{
		$contents.= fread($handle, 8192);
	}
	fclose($handle);
	return $contents;
}
function read_net_file($request) // ok : return string || error : return false
{
	//$fp = @fsockopen($aseco->server->jfreu->net_server, 80, $errno, $errstr, 10);
	//if (!$fp) return "ERROR";
	$handle = @fopen($request, "rb");
	if(!$handle)
	{
		return "ERROR";
	}
	$contents = '';
	while (!feof($handle))
	{
		$contents.= fread($handle, 8192);
	}
	fclose($handle);
	return $contents;
}
function forced_vote(&$aseco,$command)
{
	if($aseco->server->jfreu->forcedvote==1)
	{
		foreach($aseco->server->players->player_list as $pl)
		{
			$aseco->server->jfreu->playerlist[$pl->login]->other_panel=1;
			jfreu_force_vote($aseco,$pl->login,already_voted_karma($aseco,$pl->login));
			//jfreu_display($aseco,$pl->login);
		}
	}
	else
	{
		return -1;
	}
}
function save_challenge_info(&$aseco,$command)
{
	$aseco->server->jfreu->lastmapID=$aseco->server->challenge->id;
	$aseco->server->jfreu->lastmapName=$aseco->server->challenge->name;
}
function KarmaVoteLastMap(&$aseco, &$command, $vote) // from RASP
{
	$login_id = $command['author']->login;
	if($vote==-1)
	{
		$aseco->console_text('[VOTE] : "'.$login_id.'" voted "Bad" for "'.clean_nick($aseco->server->jfreu->lastmapName).'" ID :'.$aseco->server->jfreu->lastmapID.'.');
	}
	elseif($vote==1)
	{
		$aseco->console_text('[VOTE] : "'.$login_id.'" voted "Good" for "'.clean_nick($aseco->server->jfreu->lastmapName).'" ID :'.$aseco->server->jfreu->lastmapID.'.');
	}
	$query = 'SELECT Id FROM players WHERE Login=' . quotedString($login_id);
	$res = mysql_query($query);
	if (mysql_num_rows($res) > 0)
	{
		$row = mysql_fetch_row($res);
		$pid = $row[0];
	}
	else
	{
		$aseco->console_text('no player!');
	 	return;
	}
	mysql_free_result($res);
	$query2 = 'SELECT Id, Score FROM rs_karma WHERE PlayerId=' . $pid . ' AND ChallengeId=' . $aseco->server->jfreu->lastmapID;
	$res2 = mysql_query($query2);
	if (mysql_num_rows($res2) > 0)
	{
		$row = mysql_fetch_object($res2);
		if ($row->Score == $vote)
		{
			$message = $aseco->formatColors('{#highlite} You have already voted for this track');
			$aseco->addCall('ChatSendServerMessageToLogin', array($message, $login_id));
		}
		else
		{
			$query3 = 'UPDATE rs_karma SET Score=' . $vote . ' WHERE Id='.$row->Id;
			mysql_query($query3);
			if (mysql_affected_rows() < 1)
			{
				$msg = $aseco->formatColors('{#highlite} Vote Failed!');
				$aseco->addCall('ChatSendServerMessageToLogin', array($msg, $login_id));
			}
			else
			{
				$msg = $aseco->formatColors('{#highlite} Vote Successful!');
				$aseco->addCall('ChatSendServerMessageToLogin', array($msg, $login_id));
				get_karmaLastTrack($aseco,$aseco->server->jfreu->lastmapID,$login_id);
				//chat_karmaLastMap($aseco, $command);
			}
		}
	}
	else
	{
		$query3 = 'INSERT INTO rs_karma (Score, PlayerId, ChallengeId) VALUES (' . $vote . ', ' . $pid . ', ' . $aseco->server->jfreu->lastmapID . ')';
		mysql_query($query3);
		if (mysql_affected_rows() < 1)
		{
			$msg = $aseco->formatColors('{#highlite} Vote Failed!');
			$aseco->addCall('ChatSendServerMessageToLogin', array($msg, $login_id));
		}
		else
		{
			$msg = $aseco->formatColors('{#highlite} Vote Successful!');
			$aseco->addCall('ChatSendServerMessageToLogin', array($msg, $login_id));
			get_karmaLastTrack($aseco,$aseco->server->jfreu->lastmapID,$login_id);
			//chat_karma($aseco, $command);
		}
	}
	mysql_free_result($res2);
}
function get_karmaLastTrack(&$aseco, $challengeID,$login) // from RASP
{
	$query = 'SELECT sum(score) as karma FROM rs_karma WHERE ChallengeId=' . $challengeID;
	$res = mysql_query($query);
	if ( mysql_num_rows($res) == 1 )
	{
		$row = mysql_fetch_row($res);
		$karma = $row[0];
	}
	else
	{
		$karma = 0;
	}
	if (!isset($karma) )
	{
		$karma = 0;
	}
	mysql_free_result($res);
	$message = formatText('{#interact}Last Track Karma: {#highlite}{1}', $karma);
	$message = $aseco->formatColors($message);
	$aseco->addCall('ChatSendServerMessageToLogin', array($message, $login));
}
function challenge_sendbill(&$aseco,$login,$challenge_ID)
{
	foreach($aseco->server->jfreu->challenge_list as $challenge_temp)
	{
		if($challenge_temp->id==$challenge_ID)
		{
			$challenge=$challenge_temp;
		}
	}
	if(!isset($challenge))
	{
		return -1;
	}
	$amount=$challenge->price;
	if(isset($challenge->challengers[$login]))
	{
		return 1;
	}
	if($amount>0)
	{
		settype($amount,'integer');
		$aseco->client->query("SendBill",$login,$amount,"WeekChallenge","serveur");
		$aseco->server->jfreu->playerlist[$login]->bill_challenge=array($aseco->client->getResponse(),$challenge_ID);
	}
}
function challenge_register_challenger(&$aseco,$bill)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color;
	$billid=$bill[0];
	$state=$bill[1];
	$statename=$bill[2];
	$transactionid=$bill[3];
	if($state!=4)
	{
		if($state==5)
		{
			foreach($aseco->server->jfreu->playerlist as $login=>$pl)
			{
				if($pl->bill_challenge[0]==$billid)
				{
					unset($aseco->server->jfreu->playerlist[$login]->bill_challenge);
					return 0;
				}
			}
			return 0;
		}
	}
	else
	{
		if(!empty($aseco->server->jfreu->playerlist))
		{
			foreach($aseco->server->jfreu->playerlist as $login=>$pl)
			{
				if($pl->bill_challenge[0]==$billid)
				{
					$challengeId=$pl->bill_challenge[1];
					$player = $aseco->server->players->getPlayer($login);
					$request="http://".$aseco->server->jfreu->net_server.'/weekChallenge/index.php?key='.$aseco->server->jfreu->server_key.'&addchallenger&id='.$challengeId.'&login='.$login.'&nick='.nick_to_http($player->nickname);
					if(!($ok_message=read_net_file($request) || get_error($ok_message)))
					{
						if(!($ok_message=net_request($aseco,$request,"register".$challengeId."_".$login) || get_error($ok_message)))
						{
							echo "ERROR : can't register player(".$login.")\n";
							return -1;
						}
					}
					foreach($aseco->server->jfreu->challenge_list as $challenge_temp)
					{
						if($challenge_temp->id==$challengeId)
						{
							$challenge=$challenge_temp;
						}
					}
					if(!isset($challenge))
					{
						return -1;
					}
					$challenge->challengers[$login]=0;
					$message=$yel.">> ".$col."New weekChallenger ".$whi.clean_nick($player->nickname).$col." on ".$whi.$challenge->name.$col.".";
					$aseco->addCall('ChatSendServerMessage', array($message));
					return 1;
				}
			}
		}
	}
	return 0;
}
function challenge_playerfinish($aseco, $finish_item)
{
	if(challenge_is_banned(&$aseco,$finish_item->player->login)==1) // player banned
	{
		return 0;
	}
	if($aseco->server->jfreu->challenge==0 || $finish_item->score==0 || $aseco->server->jfreu->challenge_this_track!=1 || $aseco->server->gameinfo->getMode()=="Stunts")
	{
		return 0;
	}
	$login=$finish_item->player->login;
	
	// challenge track && player is challenger && score > current score && challenge status =0
	foreach($aseco->server->jfreu->challenge_list as $challenge_temp)
	{
		if($challenge_temp->status==0 && $challenge_temp->trackuid==$aseco->server->challenge->uid && isset($challenge_temp->challengers[$login]) && ($challenge_temp->challengers[$login]>$finish_item->score || $challenge_temp->challengers[$login]==0))
		{
			$challenge_temp->challengers[$finish_item->player->login]=$finish_item->score;
			challenge_update_score($aseco,$challenge_temp->name,$challenge_temp->id,$finish_item->player->login,$finish_item->score);
		}
	}
}
function challenge_update_score(&$aseco,$challengeName,$challengeID,$login,$score)
{
	// new score
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color;
	$request="http://".$aseco->server->jfreu->net_server.'/weekChallenge/index.php?key='.$aseco->server->jfreu->server_key.'&id='.$challengeID.'&sendscore&login='.$login.'&score='.$score;
	if(!($rank=net_request($aseco,$request,"update".$challengeID."_".$login)) || get_error($rank))
	{
		$player = $aseco->server->players->getPlayer($login);
		$message=$yel.">> ".$whi.clean_nick($player->nickname).$col." took the ".$red."?. ".$whi.$challengeName.$col." Rank with a time of (".$whi.formatTime($score).$col.")!";
		$aseco->addCall("ChatSendServerMessage", array($message));
		return 0;				
	}
	echo "[Challenge] update score : challengeID(".$challengeID.") login(".$login.") score(".$score.")\n";
	$player = $aseco->server->players->getPlayer($login);
	$message=$yel.">> ".$whi.clean_nick($player->nickname).$col." took the ".$whi.$rank.".".$whi.$challengeName.$col." Rank with a time of (".$whi.formatTime($score).$col.")!";
	$aseco->addCall("ChatSendServerMessage", array($message));
	return 1;
}
function challenge_this_challenge($aseco,$challenge)
{
	if($aseco->server->jfreu->challenge==0 || $aseco->server->gameinfo->getMode()=="Stunts")
	{
		//echo "ERROR 16878\n";
		return 0;
	}
	foreach($aseco->server->jfreu->challenge_list as $challenge_temp)
	{
		if($challenge_temp->status==0)
		{
			if($challenge->uid==$challenge_temp->trackuid)
			{
				$yel=$aseco->server->jfreu->yellow;
				$col=$aseco->server->jfreu->color;
				$message=$yel.">> ".$col."WeekChallenge Track !!";
				$aseco->addCall("ChatSendServerMessage", array($message));
				$aseco->server->jfreu->challenge_this_track=1;
				return 1;
			}
		}
	}
	return 0;
}
function net_request(&$aseco,$request,$type)
{
	$answer=read_net_file($request);
	if(get_error($answer))
	{
		$aseco->server->jfreu->failed_requests[$type]=$request;
		echo "[Challenge] net request failed : ".$type."\n";
		return "ERROR";
	}
	else
	{
		if(isset($aseco->server->jfreu->failed_requests[$type]))
		{
			unset($aseco->server->jfreu->failed_requests[$type]);
		}
	}
	return $answer;
}
function do_failed_net_requests(&$aseco,$command)
{
	if(isset($aseco->server->jfreu->failed_requests) && count($aseco->server->jfreu->failed_requests)>0)
	{
		foreach($aseco->server->jfreu->failed_requests as $type=>$request)
		{
			echo "[Challenge] Do failed Net request : ".$type."\n";
			$answer=net_request($aseco,$request,$type);
			if(!get_error($answer))
			{
				unset($aseco->server->jfreu->failed_requests[$type]);
			}
		}
	}
}
function challenge_get_time(&$aseco,$login,&$challengers) // time | $F00no time
{
	if(!isset($challengers[$login]) || $challengers[$login]==0)
	{
		return '$F00No Time';
	}
	else
	{
		return formatTime($challengers[$login]);
	}
}
function turn_on(&$aseco,$command)
{
	//weekchallenge
	if($aseco->server->jfreu->weekchallenge_on==1 && $aseco->server->jfreu->challenge==0)
	{
		//$aseco->server->jfreu->weekchallenge=1;
		if(!isset($aseco->server->jfreu->failed_requests["get_challenge"]))
		{
			jfreu_load_challenges($aseco);
		}
	}
	if($aseco->server->jfreu->weekchallenge_on==0 && $aseco->server->jfreu->challenge==1)
	{
		$aseco->server->jfreu->challenge=0;
	}
	
	//betsystem
	if($aseco->server->jfreu->betsystem_on==1 && $aseco->server->jfreu->betsystem==0)
	{
		$aseco->server->jfreu->betsystem=1;
		bet_reset_bets($aseco);
	}
	if($aseco->server->jfreu->betsystem_on==0 && $aseco->server->jfreu->betsystem==1)
	{
		$aseco->server->jfreu->betsystem=0;
		bet_reset_bets($aseco);
	}
	
	//racewinner
	if($aseco->server->jfreu->paywinner_on==1 && $aseco->server->jfreu->paywinner==0)
	{
		$aseco->server->jfreu->paywinner=1;
		reset_pay_winner($aseco);
	}
	if($aseco->server->jfreu->paywinner_on==0 && $aseco->server->jfreu->paywinner==1)
	{
		$aseco->server->jfreu->paywinner=0;
		reset_pay_winner($aseco);
	}
}
function jfreu_time($time) // return formatted endtime GMT
{
	if($time<time()) 
		return "Over";
	else
		return date("d.m.Y - H:i", $time- date("Z",$time)).' [GMT]';
}
function jfreu_time3($time) // return formatted  |time()-$time|
{
	$time=time()-$time;
	if($time<0) return "Over";
	$m=floor($time/60);
	if($m==0) if($time>0) return $time." sec(s)";
	$h=floor($m/60);
	if($h==0) if($m>0) return $m." min(s)";
	$d=floor($h/24);
	if($d==0) if($h>0) return $h." hrs(s)";
	$w=floor($d/7);
	if($w==0) if($d>0) return $d." day(s)";
	if($w>0) return $w." week(s)";
}
function jfreu_time2($time) // return formatted  |$time|
{
	if($time<0) return "Over";
	$m=floor($time/60);
	if($m==0) if($time>0) return $time." sec(s)";
	$h=floor($m/60);
	if($h==0) if($m>0) return $m." min(s)";
	$d=floor($h/24);
	if($d==0) if($h>0) return $h." hrs(s)";
	$w=floor($d/7);
	if($w==0) if($d>0) return $d." day(s)";
	if($w>0) return $w." week(s)";
}
function challenge_pay_winners(&$aseco)
{
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color;
	if($aseco->server->jfreu->bank!=1)
	{
		return 0;
	}
	$request="http://".$aseco->server->jfreu->net_server."/weekChallenge/?key=".$aseco->server->jfreu->server_key."&paywinners";
	if(!($winners_coppers=read_file($request)) || get_error($winners_coppers))
	{
		echo "[Challenge] Pay winners : All challenges paid\n";
		return 0;
	}
	$winner_coppers=explode("|", $winners_coppers);
	$i=0;
	$winner_copper_array=array();
	$message2=$yel.">> ";
	while($i<count($winner_coppers))
	{
		$winner_copper_array=explode(":", $winner_coppers[$i]);
		challenge_pay_winner($aseco,$winner_copper_array[1],$winner_copper_array[0]);
		$message2.=$whi.$winner_copper_array[0].$col."[".$whi.$winner_copper_array[1]." cp".$col."] . ";
		$i++;
	}
	$message=">> Server pay weekChallenge winners :";
	$aseco->addCall("ChatSendServerMessage", array($message));
	$aseco->addCall("ChatSendServerMessage", array($message2));
	echo "[Challenge] Pay winners : ".$winners_coppers."\n";
}
function challenge_pay_winner(&$aseco,$amount,$login)
{
	if($amount>0)
	{
		settype($amount,'integer');
		$aseco->addCall("Pay", array($login,$amount,'Coppers won [Jfreu\'s plugin] WeekChallenge winner'));
	}
}
function challenge_get_bank(&$aseco)
{
	if($aseco->server->jfreu->bank!=1)
	{
		return 0;
	}
	$total=0;
	foreach($aseco->server->jfreu->challenge_list as $challenge)
	{
		if($challenge->status!=1)
		{
			$total+=$challenge->jackpot;
		}
	}
	return $total;
}
function challenge_finished(&$aseco)
{
	if(!isset($aseco->server->jfreu->endTime) || $aseco->server->jfreu->endTime>time() || $aseco->server->jfreu->endTime==0)
	{
		return 0;
	}
	$red=$aseco->server->jfreu->red;
	$yel=$aseco->server->jfreu->yellow;
	$whi=$aseco->server->jfreu->white;
	$blu=$aseco->server->jfreu->blue;
	$gre=$aseco->server->jfreu->green;
	$col=$aseco->server->jfreu->color;
	$message=$yel.">> ".$col."The WeekChallenge#".$aseco->server->jfreu->challengeid." is over.";
	$aseco->addCall("ChatSendServerMessage", array($message));
	$aseco->server->jfreu->weekchallenge=0;
	return 1;
}
function already_voted_karma($aseco,$login)
{
	$query = 'SELECT Id FROM players WHERE Login=' . quotedString($login);
	$res = mysql_query($query);
	if (mysql_num_rows($res) > 0)
	{
		$row = mysql_fetch_row($res);
		$pid = $row[0];
	}
	else
	{
	 	return 0;
	}
	mysql_free_result($res);
	$query2 = 'SELECT Id, Score FROM rs_karma WHERE PlayerId=' . $pid . ' AND ChallengeId=' . $aseco->server->jfreu->lastmapID;
	$res2 = mysql_query($query2);
	if (mysql_num_rows($res2) > 0)
	{
		$row = mysql_fetch_object($res2);
		if ($row->Score ==1)
		{
			return 1;
		}
		if ($row->Score ==-1)
		{
			return -1;
		}
	}
	return 0;
}
//Function by ck|cyrus aka Martin
//martin@die-webber.com
//ICQ 85020221
// 03-01-2007
function StringExplode($string,$maxlength=150) //TMU Supports a max chatmessage of 150 chars 
{
  if (strlen($string)>$maxlength)
  {
  	$temp = "";
		$sExpl=split(" ",$string);
    for ($i=0; $i<count($sExpl); $i++) 
    {
    	
    	if(strlen($temp.$sExpl[$i])>$maxlength)
    	{
    		$output[] = rtrim($temp);
    		$temp = "";
    	} 
    	$temp.=$sExpl[$i].' ';
    }
    $output[] = rtrim($temp);
    return $output;
  }
  else
  { 
  	$output[] = $string;
  	return $output;
  }
}
function nick_to_http($nick)
{
	return rawurlencode($nick);
}
function update_challenges(&$aseco)
{
	if($aseco->server->jfreu->challenge==0)
	{
		return 0;
	}
	if((($aseco->server->jfreu->challenge_update_time*60)+$aseco->server->jfreu->challenge_last_update)<time())
	{
		//echo "UT=".$aseco->server->jfreu->challenge_update_time.", LUT=".$aseco->server->jfreu->challenge_last_update.", T=".time()."\n";
		echo "[Challenge] ######## AutoUpdate #########\n";
		$aseco->server->jfreu->challenge_last_update=time();
		jfreu_load_challenges($aseco);
	}
	return 1;
}


/*function challenge_add_jukebox(&$aseco, &$uid)
{
	global $player, $jukebox, $aseco, $rasp, $jb_buffer;
	if (array_key_exists($uid, $jukebox)) 				// find by uid in jukebox
	{
		$message = $aseco->formatColors('{#server}>{#emotic} This track has already been added');
		$aseco->addCall('ChatSendServerMessageToLogin', array($message, $login));
		return;
	}
	elseif (in_array($uid, $jb_buffer))
	{
		$message = $aseco->formatColors('{#server}>{#emotic} This track has been played recently. Wait a while before adding it again.');
		$aseco->addCall('ChatSendServerMessageToLogin', array($message, $login));
		return;
	}
	$jukebox[$uid]['FileName'] = $player->tracklist[$jid]['filename'];
	$jukebox[$uid]['Name'] = $player->tracklist[$jid]['name'];
	$jukebox[$uid]['Nick'] = $player->nickname;
	$jukebox[$uid]['tmx'] = false;
	$jukebox[$uid]['uid'] = $uid;
	$jukebox[$uid]['env'] = $player->tracklist[$jid]['env'];
	$message = formatText($rasp->messages['JUKEBOX'][0], $player->tracklist[$jid]['name'], stripFormatting($player->nickname));
	$message = $aseco->formatColors($message);
	$aseco->addCall('ChatSendServerMessage', array($message));
	return;
}*/
/*
function challenge_add_track(&$aseco, $uid,$login)
{
	global $tmxvote, $tmxdir, $feature_tmxadd, $jb_env, $jukebox;
	$tracktypes = array();
	$tracktypes['TMO'] = array(0 => 7458, 'original');
	$tracktypes['TMS'] = array(0 => 7455, 'sunrise');
	$tracktypes['TMN'] = array(0 => 7456, 'nations');
	$tracktypes['TMU'] = array(0 => 7459, 'united');

	$params = explode(' ', trim($command['params']));
	$tmxid = $params[0];

	if ($feature_tmxadd == true)
	{
		$remotefile = 'http://united.tm-exchange.com/get.aspx?action=trackgbx&uid=' . $uid;
		if (!$stream = fopen($remotefile, 'r'))
		{
			$message = $aseco->formatColors('{#server}>{#emotic} Track not found, or error downloading.');
			$aseco->addCall('ChatSendServerMessageToLogin', array($message, $login));
			return;
		}
		else
		{
			if (!$file = stream_get_contents($stream))
			{
				$message = $aseco->formatColors('{#server}>{#emotic} Track not found, or error downloading.');
				$aseco->addCall('ChatSendServerMessageToLogin', array($message, $login));
				return;
			}
			$sepchar = substr($aseco->server->trackdir, -1, 1);
			$partialdir = $tmxdir . $sepchar . $tmxid . '.challenge.gbx';
			$localfile = $aseco->server->trackdir . $partialdir;
			if (file_exists($localfile))
			{
				if (!unlink($localfile))
				{
					$message = $aseco->formatColors('{#server}>{#emotic} Error erasing old file. Please contact admin');
					$aseco->addCall('ChatSendServerMessageToLogin', array($message, $login));
					return;
				}
			}
			if (!$lfile = fopen($localfile, 'w+'))
			{
				$message = $aseco->formatColors('{#server}>{#emotic} Error creating file. Please contact admin');
				$aseco->addCall('ChatSendServerMessageToLogin', array($message, $login));
				return;
			}
			if (!fwrite($lfile, $file))
			{
				$message = $aseco->formatColors('{#server}>{#emotic} Error saving file - unable to write data. Please contact admin');
				$aseco->addCall('ChatSendServerMessageToLogin', array($message, $login));
				return;
			}
			fclose($lfile);		// can't do filesize while it's open, might have also caused problems with tmserver giving back info
			if (filesize($localfile) == $tracktypes[$tracktype][0])
			{
				$message = $aseco->formatColors('{#server}>{#emotic} No such track on TMX');
				$aseco->addCall('ChatSendServerMessageToLogin', array($message, $login));
				unlink($localfile);
				return;
			}
			else
			{
				$newtrk = getChallengeData($localfile, True);		// 2nd parm is whether or not to get players & votes required
				if ( $newtrk['votes'] == 500 && $newtrk['name'] == 'Not a GBX file')
				{
					$message = $aseco->formatColors('{#server}>{#emotic} No such track on TMX');
					$aseco->addCall('ChatSendServerMessageToLogin', array($message, $login));
					unlink($localfile);
				}
				else
				{
					if(isset($jb_env)&&strlen($jb_env)>0)			// it exists and has data, go check it
					{
						if ( stripos($jb_env, $newtrk['environment']) === false )
						{
							$msg = '{#server}>{#highlite} Environment (' . $newtrk['environment'] . ') not acceptable on this server. Try again.';
							$message = $aseco->formatColors($msg);
							$aseco->addCall('ChatSendServerMessageToLogin', array($message, $login));
							unlink($localfile);
							return;
						}
					}
					$ctr = 0;
					getAllChallenges($player, '*', '*');		// populate players tracklist with all current tracks
					foreach($player->tracklist as $key)
					{
						if ( $key['uid'] == $newtrk['uid'] )
						{
							$msg = '{#server}>{#highlite} File already in track list, added via jukebox';
							$message = $aseco->formatColors($msg);
							$aseco->addCall('ChatSendServerMessageToLogin', array($message, $login));
							$command['params'] = $ctr;
							chat_jukebox($aseco, $command);
							return;
						}
						$ctr++;
					}
					$uid = $tmxadd['uid'];
					$jukebox[$uid]['FileName'] = $tmxadd['filename'];
					$jukebox[$uid]['Name'] = stripFormatting($tmxadd['name']);
					$jukebox[$uid]['Nick'] = $tmxadd['nick'];
					$jukebox[$uid]['tmx'] = true;
					$jukebox[$uid]['uid'] = $uid;
					$jukebox[$uid]['env'] = $tmxadd['env'];
					$msg = '{#server}>> {#emotic} The challenge track : {#highlite}' . stripFormatting($tmxadd['name']) . '{#emotic} has been added to the jukebox.';
					$message = $aseco->formatColors($msg);
					$aseco->addCall('ChatSendServerMessage', array($message));
					return;
				}
			}
		}
	}
	else
	{
		$message = $aseco->formatColors('{#emotic}/add is not currently enabled on this server');
		$aseco->addCall('ChatSendServerMessageToLogin', array($message, $login));
	}
}*/
?>